xfsprogs-6.18.0 (24 Dec 2025)
	mkfs: adjust_nr_zones for zoned file system on conventional devices (Christoph Hellwig)
	xfs_logprint: fix pointer bug (Darrick J. Wong)
	mdrestore: fix restore_v2() superblock length check (Pavel Reichl)
	mkfs: add 2025 LTS config file (Darrick J. Wong)
	mkfs: enable new features by default (Darrick J. Wong)
	libfrog: fix incorrect FS_IOC_FSSETXATTR argument to ioctl() (Arkadiusz Miskiewicz)
	xfs: prevent gc from picking the same zone twice (Christoph Hellwig)
	xfs: improve default maximum number of open zones (Damien Le Moal)
	xfs: fix log CRC mismatches between i386 and other architectures (Christoph Hellwig)
	xfs: remove deprecated sysctl knobs (Darrick J. Wong)
	xfs: remove deprecated mount options (Darrick J. Wong)
	man2: fix getparents ioctl manpage (Darrick J. Wong)
	xfs_db: document the rtsb command (Darrick J. Wong)
	libxfs: fix build warnings (Darrick J. Wong)
	xfs_scrub: fix null pointer crash in scrub_render_ino_descr (Darrick J. Wong)
	metadump: catch used extent array overflow (Carlos Maiolino)
	mkfs: fix zone capacity check for sequential zones (Carlos Maiolino)
	libxfs: support reproducible filesystems using deterministic time/seed (Luca Di Maio)
	Fix alloc/free of cache item (Torsten Rupp)
	xfs_io: use the XFS_ERRTAG macro to generate injection targets (Christoph Hellwig)
	repair/prefetch.c: Create one workqueue with multiple workers (Chandan Babu R)
	libfrog: Prevent unnecessary waking of worker thread when using bounded workqueues (Chandan Babu R)
	proto: fix file descriptor leak (Luca Di Maio)
	mkfs: split zone reset from discard (Christoph Hellwig)
	mkfs: move clearing LIBXFS_DIRECT into check_device_type (Christoph Hellwig)
	mkfs: improve the error message in adjust_nr_zones (Christoph Hellwig)
	mkfs: improve the error message from check_device_type (Christoph Hellwig)
	xfs_copy: improve the error message when mkfs is in progress (Christoph Hellwig)

xfsprogs-6.17.0 (20 Oct 2025)
	xfs_scrub_fail: reduce security lockdowns to avoid postfix problems (Darrick J. Wong)
	mkfs: fix copy-paste error in calculate_rtgroup_geometry (Darrick J. Wong)
	xfs_scrub: fix strerror_r usage yet again (Darrick J. Wong)
	mkfs: fix libxfs_iget return value sign inversion (Darrick J. Wong)
	xfs_scrub: Use POSIX-conformant strerror_r (A. Wilcox)
	xfs_db: use file_setattr to copy attributes on special files with rdump (Andrey Albershteyn)
	xfs_io: make ls/chattr work with special files (Andrey Albershteyn)
	xfs_quota: utilize file_setattr to set prjid on special files (Andrey Albershteyn)
	configure: Base NEED_INTERNAL_STATX on libc headers first (Johannes Nixdorf)
	xfs_io: add FALLOC_FL_WRITE_ZEROES support (Zhang Yi)
	xfsprogs: fix utcnow deprecation warning in xfs_scrub_all.py (Christian Kujau)
	Improve information about logbsize valid values (Carlos Maiolino)
	proto: add ability to populate a filesystem from a directory (Luca Di Maio)

xfsprogs-6.16.0 (26 Aug 2025)
	Document current limitation of shrinking fs (Xavier Claude)
	mkfs: require reflink for max_atomic_write option (John Garry)
	xfs_scrub: remove EXPERIMENTAL warnings (Darrick J. Wong)
	mkfs: allow users to configure the desired maximum atomic write size (Darrick J. Wong)
	mkfs: try to align AG size based on atomic write capabilities (Darrick J. Wong)
	mkfs: autodetect log stripe unit for external log devices (Darrick J. Wong)
	mkfs: don't complain about overly large auto-detected log stripe units (Darrick J. Wong)
	xfs_io: dump new atomic_write_unit_max_opt statx field (Darrick J. Wong)
	xfs_db: create an untorn_max subcommand (Darrick J. Wong)

xfsprogs-6.15.0 (23 Jun 2025)
	xfs_mdrestore: don't allow restoring onto zoned block devices (Christoph Hellwig)
	man: adjust description of the statx manpage (Darrick J. Wong)
	xfs_protofile: fix permission octet when suid/guid is set (Luca Di Maio)
	xfs_repair: fix libxfs abstraction mess (Darrick J. Wong)
	xfs_growfs: support internal RT devices (Christoph Hellwig)
	xfs_mdrestore: support internal RT devices (Christoph Hellwig)
	xfs_scrub: support internal RT device (Christoph Hellwig)
	xfs_spaceman: handle internal RT devices (Christoph Hellwig)
	xfs_io: handle internal RT devices in fsmap output (Christoph Hellwig)
	xfs_io: don't re-query fs_path information in fsmap_f (Christoph Hellwig)
	xfs_io: correctly report RGs with internal rt dev in bmap output (Christoph Hellwig)
	man: document XFS_FSOP_GEOM_FLAGS_ZONED (Christoph Hellwig)
	xfs_mkfs: document the new zoned options in the man page (Christoph Hellwig)
	xfs_mkfs: reflink conflicts with zoned file systems for now (Christoph Hellwig)
	xfs_mkfs: default to rtinherit=1 for zoned file systems (Christoph Hellwig)
	xfs_mkfs: calculate zone overprovisioning when specifying size (Christoph Hellwig)
	xfs_mkfs: support creating file system with zoned RT devices (Christoph Hellwig)
	xfs_mkfs: factor out a validate_rtgroup_geometry helper (Christoph Hellwig)
	xfs_repair: validate rt groups vs reported hardware zones (Christoph Hellwig)
	xfs_repair: fix the RT device check in process_dinode_int (Christoph Hellwig)
	xfs_repair: support repairing zoned file systems (Christoph Hellwig)
	libfrog: report the zoned geometry (Christoph Hellwig)
	xfs_repair: phase6: scan longform entries before header check (Bill O'Donnell)
	xfs_repair: Bump link count if longform_dir2_rebuild yields shortform dir (Eric Sandeen)
	mkfs: fix the issue of maxpct set to 0 not taking effect (liuh)
	mkfs: fix blkid probe API violations causing weird output (Darrick J. Wong)
	xfs_io: make statx mask parsing more generally useful (Darrick J. Wong)
	xfs_io: redefine what statx -m all does (Darrick J. Wong)
	xfs_io: catch statx fields up to 6.15 (Darrick J. Wong)
	man: fix missing cachestat manpage (Darrick J. Wong)

xfsprogs-6.14.0 (08 Apr 2025)
	xfs_scrub_all: localize the strings in the program (Darrick J. Wong)
	xfs_protofile: add messages to localization catalog (Darrick J. Wong)
	Makefile: inject package name/version/bugreport into pot file (Darrick J. Wong)
	xfs_scrub_all: rename source code to .py.in (Darrick J. Wong)
	xfs_protofile: rename source code to .py.in (Darrick J. Wong)
	xfs_repair: handling a block with bad crc, bad uuid, and bad magic number needs fixing (Bill O'Donnell)
	xfs_repair: fix stupid argument error in verify_inode_chunk (Darrick J. Wong)
	xfs_repair: fix infinite loop in longform_dir2_entry_check* (Darrick J. Wong)
	xfs_repair: fix crash in reset_rt_metadir_inodes (Darrick J. Wong)
	xfs_repair: don't recreate /quota metadir if there are no quota inodes (Darrick J. Wong)
	xfs_repair: fix wording of error message about leftover CoW blocks on the rt device (Darrick J. Wong)
	xfs_io: Add cachestat syscall support (Ritesh Harjani (IBM))
	xfs_io: Add RWF_DONTCACHE support to preadv2 (Ritesh Harjani (IBM))
	xfs_io: Add RWF_DONTCACHE support to pwritev2 (Ritesh Harjani (IBM))
	xfs_io: Add support for preadv2 (Ritesh Harjani (IBM))
	make: remove the .extradep file in libxfs on "make clean" (Theodore Ts'o)
	xfs_{admin,repair},man5: tell the user to mount with nouuid for snapshots (Darrick J. Wong)
	xfsprogs: Fix mismatched return type of filesize() (Pavel Reichl)
	xfs_io: don't fail FS_IOC_FSGETXATTR on filesystems that lack support (Anthony Iliopoulos)
	configure: additionally get icu-uc from pkg-config (Alyssa Ross)
	xfs_scrub: use the display mountpoint for reporting file corruptions (Darrick J. Wong)
	xfs_scrub: don't warn about zero width joiner control characters (Darrick J. Wong)
	xfs_scrub: fix buffer overflow in string_escape (Darrick J. Wong)
	xfs_db: add command to copy directory trees out of filesystems (Darrick J. Wong)
	xfs_db: make listdir more generally useful (Darrick J. Wong)
	xfs_db: use an empty transaction to try to prevent livelocks in path_navigate (Darrick J. Wong)
	xfs_db: pass const pointers when we're not modifying them (Darrick J. Wong)
	mkfs: enable reflink on the realtime device (Darrick J. Wong)
	mkfs: validate CoW extent size hint when rtinherit is set (Darrick J. Wong)
	xfs_logprint: report realtime CUIs (Darrick J. Wong)
	xfs_repair: validate CoW extent size hint on rtinherit directories (Darrick J. Wong)
	xfs_repair: allow realtime files to have the reflink flag set (Darrick J. Wong)
	xfs_repair: rebuild the realtime refcount btree (Darrick J. Wong)
	xfs_repair: reject unwritten shared extents (Darrick J. Wong)
	xfs_repair: check existing realtime refcountbt entries against observed refcounts (Darrick J. Wong)
	xfs_repair: compute refcount data for the realtime groups (Darrick J. Wong)
	xfs_repair: find and mark the rtrefcountbt inode (Darrick J. Wong)
	xfs_repair: use realtime refcount btree data to check block types (Darrick J. Wong)
	xfs_repair: allow CoW staging extents in the realtime rmap records (Darrick J. Wong)
	xfs_spaceman: report health of the realtime refcount btree (Darrick J. Wong)
	xfs_db: add rtrefcount reservations to the rgresv command (Darrick J. Wong)
	xfs_db: copy the realtime refcount btree (Darrick J. Wong)
	xfs_db: support the realtime refcountbt (Darrick J. Wong)
	xfs_db: display the realtime refcount btree contents (Darrick J. Wong)
	man: document userspace API changes due to rt reflink (Darrick J. Wong)
	mkfs: create the realtime rmap inode (Darrick J. Wong)
	xfs_logprint: report realtime RUIs (Darrick J. Wong)
	xfs_repair: reserve per-AG space while rebuilding rt metadata (Darrick J. Wong)
	xfs_repair: rebuild the bmap btree for realtime files (Darrick J. Wong)
	xfs_repair: check for global free space concerns with default btree slack levels (Darrick J. Wong)
	xfs_repair: rebuild the realtime rmap btree (Darrick J. Wong)
	xfs_repair: always check realtime file mappings against incore info (Darrick J. Wong)
	xfs_repair: check existing realtime rmapbt entries against observed rmaps (Darrick J. Wong)
	xfs_repair: find and mark the rtrmapbt inodes (Darrick J. Wong)
	xfs_repair: refactor realtime inode check (Darrick J. Wong)
	xfs_repair: create a new set of incore rmap information for rt groups (Darrick J. Wong)
	xfs_repair: use realtime rmap btree data to check block types (Darrick J. Wong)
	xfs_repair: flag suspect long-format btree blocks (Darrick J. Wong)
	xfs_repair: tidy up rmap_diffkeys (Darrick J. Wong)
	xfs_spaceman: report health status of the realtime rmap btree (Darrick J. Wong)
	xfs_db: add an rgresv command (Darrick J. Wong)
	xfs_db: make fsmap query the realtime reverse mapping tree (Darrick J. Wong)
	xfs_db: copy the realtime rmap btree (Darrick J. Wong)
	xfs_db: support the realtime rmapbt (Darrick J. Wong)
	xfs_db: display the realtime rmap btree contents (Darrick J. Wong)
	xfs_db: don't abort when bmapping on a non-extents/bmbt fork (Darrick J. Wong)
	xfs_db: compute average btree height (Darrick J. Wong)
	man: document userspace API changes due to rt rmap (Darrick J. Wong)
	xfs_scrub: try harder to fill the bulkstat array with bulkstat() (Darrick J. Wong)
	xfs_scrub: ignore freed inodes when single-stepping during phase 3 (Darrick J. Wong)
	xfs_scrub: hoist the phase3 bulkstat single stepping code (Darrick J. Wong)
	xfs_scrub: don't blow away new inodes in bulkstat_single_step (Darrick J. Wong)
	xfs_scrub: return early from bulkstat_for_inumbers if no bulkstat data (Darrick J. Wong)
	xfs_scrub: don't complain if bulkstat fails (Darrick J. Wong)
	xfs_scrub: don't (re)set the bulkstat request icount incorrectly (Darrick J. Wong)
	xfs_scrub: don't double-scan inodes during phase 3 (Darrick J. Wong)
	xfs_scrub: actually iterate all the bulkstat records (Darrick J. Wong)
	xfs_scrub: selectively re-run bulkstat after re-running inumbers (Darrick J. Wong)
	xfs_scrub: remove flags argument from scrub_scan_all_inodes (Darrick J. Wong)
	xfs_scrub: call bulkstat directly if we're only scanning user files (Darrick J. Wong)
	xfs_scrub: don't report data loss in unlinked inodes twice (Darrick J. Wong)
	man: document new XFS_BULK_IREQ_METADIR flag to bulkstat (Darrick J. Wong)
	xfs_db: obfuscate rt superblock label when metadumping (Darrick J. Wong)
	mkfs,xfs_repair: don't pass a daddr as the flags argument (Darrick J. Wong)

xfsprogs-6.13.0 (13 Feb 2025)
	xfs_protofile: fix device number encoding (Darrick J. Wong)
	xfs_protofile: fix mode formatting error (Darrick J. Wong)
	mkfs: fix file size setting when interpreting a protofile (Darrick J. Wong)
	xfs_repair: require zeroed quota/rt inodes in metadir superblocks (Darrick J. Wong)
	mkfs: use a default sector size that is also suitable for the rtdev (Christoph Hellwig)
	xfs_scrub_all.timer: don't run if /var/lib/xfsprogs is readonly (Darrick J. Wong)
	xfs_logprint: Fix super block buffer interpretation issue (Chi Zhiling)
	mkfs: allow sizing realtime allocation groups for concurrency (Darrick J. Wong)
	build: initialize stack variables to zero by default (Darrick J. Wong)
	m4: fix statx override selection if /usr/include doesn't define it (Darrick J. Wong)
	mkfs: fix parsing of value-less -d/-l concurrency cli option (Darrick J. Wong)
	xfs_db: improve error message when unknown btree type given to btheight (Darrick J. Wong)
	xfs_repair: don't obliterate return codes (Darrick J. Wong)
	xfs_db: fix multiple dblock commands (Darrick J. Wong)
	xfs: don't return an error from xfs_update_last_rtgroup_size for !XFS_RT (Christoph Hellwig)
	xfs_io: add extsize command support (Ojaswin Mujoo)
	xfs_io: allow foreign FSes to show FS_IOC_FSGETXATTR details (Ojaswin Mujoo)
	mkfs: enable rt quota options (Darrick J. Wong)
	xfs_quota: report warning limits for realtime space quotas (Darrick J. Wong)
	mkfs: add quota flags when setting up filesystem (Darrick J. Wong)
	xfs_repair: try not to trash qflags on metadir filesystems (Darrick J. Wong)
	xfs_repair: support quota inodes in the metadata directory (Darrick J. Wong)
	xfs_db: support metadir quotas (Darrick J. Wong)
	libfrog: scrub quota file metapaths (Darrick J. Wong)
	mkfs: format realtime groups (Darrick J. Wong)
	mkfs: add headers to realtime bitmap blocks (Darrick J. Wong)
	xfs_scrub: use histograms to speed up phase 8 on the realtime volume (Darrick J. Wong)
	xfs_scrub: trim realtime volumes too (Darrick J. Wong)
	xfs_scrub: call GETFSMAP for each rt group in parallel (Darrick J. Wong)
	xfs_scrub: cleanup fsmap keys initialization (Christoph Hellwig)
	xfs_scrub: check rtgroup metadata directory connections (Darrick J. Wong)
	xfs_scrub: scrub realtime allocation group metadata (Darrick J. Wong)
	xfs_spaceman: report on realtime group health (Darrick J. Wong)
	xfs_mdrestore: restore rt group superblocks to realtime device (Darrick J. Wong)
	xfs_io: display rt group in verbose fsmap output (Darrick J. Wong)
	xfs_io: display rt group in verbose bmap output (Darrick J. Wong)
	xfs_io: add a command to display realtime group information (Darrick J. Wong)
	xfs_io: add a command to display allocation group information (Darrick J. Wong)
	xfs_io: support scrubbing rtgroup metadata paths (Darrick J. Wong)
	xfs_io: support scrubbing rtgroup metadata (Darrick J. Wong)
	xfs_db: report rt group and block number in the bmap command (Darrick J. Wong)
	xfs_db: dump rt summary blocks (Darrick J. Wong)
	xfs_db: dump rt bitmap blocks (Darrick J. Wong)
	xfs_db: metadump realtime devices (Darrick J. Wong)
	xfs_db: metadump metadir rt bitmap and summary files (Christoph Hellwig)
	xfs_db: enable conversion of rt space units (Darrick J. Wong)
	xfs_db: support changing the label and uuid of rt superblocks (Darrick J. Wong)
	xfs_db: support dumping realtime group data and superblocks (Darrick J. Wong)
	xfs_db: listify the definition of enum typnm (Darrick J. Wong)
	xfs_db: enable rtconvert to handle segmented rtblocks (Darrick J. Wong)
	xfs_db: enable the rtblock and rtextent commands for segmented rt block numbers (Darrick J. Wong)
	xfs_repair: repair rtbitmap and rtsummary block headers (Darrick J. Wong)
	xfs_repair: support realtime superblocks (Darrick J. Wong)
	xfs_repair: find and clobber rtgroup bitmap and summary files (Darrick J. Wong)
	xfs_repair: support realtime groups (Darrick J. Wong)
	xfs_repair: add a real per-AG bitmap abstraction (Christoph Hellwig)
	xfs_repair: simplify rt_lock handling (Christoph Hellwig)
	xfs_repair: improve rtbitmap discrepancy reporting (Darrick J. Wong)
	xfs_repair: refactor offsetof+sizeof to offsetofend (Darrick J. Wong)
	xfs_repair: refactor phase4 (Christoph Hellwig)
	xfs_repair: adjust rtbitmap/rtsummary word updates to handle big endian values (Darrick J. Wong)
	xfs_logprint: report realtime EFIs (Darrick J. Wong)
	libfrog: add bitmap_clear (Darrick J. Wong)
	libfrog: report rt groups in output (Darrick J. Wong)
	libfrog: support scrubbing rtgroup metadata paths (Darrick J. Wong)
	man: document rgextents geom field (Christoph Hellwig)
	man: document the rt group geometry ioctl (Darrick J. Wong)
	mkfs: add a utility to generate protofiles (Darrick J. Wong)
	mkfs: support copying in xattrs (Darrick J. Wong)
	mkfs: support copying in large or sparse files (Darrick J. Wong)
	mkfs.xfs: enable metadata directories (Darrick J. Wong)
	xfs_repair: do not count metadata directory files when doing quotacheck (Darrick J. Wong)
	xfs_repair: truncate and unmark orphaned metadata inodes (Darrick J. Wong)
	xfs_repair: drop all the metadata directory files during pass 4 (Darrick J. Wong)
	xfs_repair: metadata dirs are never plausible root dirs (Darrick J. Wong)
	xfs_repair: mark space used by metadata files (Darrick J. Wong)
	xfs_repair: update incore metadata state whenever we create new files (Darrick J. Wong)
	xfs_repair: don't let metadata and regular files mix (Darrick J. Wong)
	xfs_repair: rebuild the metadata directory (Darrick J. Wong)
	xfs_repair: check metadata inode flag (Darrick J. Wong)
	xfs_repair: dont check metadata directory dirent inumbers (Darrick J. Wong)
	xfs_repair: handle sb_metadirino correctly when zeroing supers (Darrick J. Wong)
	xfs_scrub: re-run metafile scrubbers during phase 5 (Darrick J. Wong)
	xfs_scrub: scan metadata directories during phase 3 (Darrick J. Wong)
	xfs_scrub: tread zero-length read verify as an IO error (Darrick J. Wong)
	xfs_spaceman: report health of metadir inodes too (Darrick J. Wong)
	xfs_io: support scrubbing metadata directory paths (Darrick J. Wong)
	xfs_io: support flag for limited bulkstat of the metadata directory (Darrick J. Wong)
	xfs_db: drop the metadata checking code from blockget (Darrick J. Wong)
	xfs_db: display di_metatype (Darrick J. Wong)
	xfs_db: show the metadata root directory when dumping superblocks (Darrick J. Wong)
	xfs_db: support metadata directories in the path command (Darrick J. Wong)
	xfs_db: don't obfuscate metadata directories and attributes (Darrick J. Wong)
	xfs_db: report metadir support for version command (Darrick J. Wong)
	xfs_db: disable xfs_check when metadir is enabled (Darrick J. Wong)
	xfs_io: support scrubbing metadata directory paths (Darrick J. Wong)
	libfrog: report metadata directories in the geometry report (Darrick J. Wong)
	man: update scrub ioctl documentation for metadir (Darrick J. Wong)
	man2: document metadata directory flag in fsgeom ioctl (Darrick J. Wong)
	man: document the -n parent mkfs option (Darrick J. Wong)
	man: fix ioctl_xfs_commit_range man page install (Jan Palus)
	xfs_repair: fix maximum file offset comparison (Darrick J. Wong)

xfsprogs-6.12.0 (02 Dec 2024)
	xfs_io: add support for atomic write statx fields (Catherine Hoang)
	xfs_repair: fix crasher in pf_queuing_worker (Darrick J. Wong)
	xfs: Reduce unnecessary searches when searching for the best extents (Chi Zhiling)
	xfs_spaceman: add dependency on libhandle target (Jan Palus)
	mkfs: add a config file for 6.12 LTS kernels (Darrick J. Wong)
	xfs_scrub_all: wait for services to start activating (Darrick J. Wong)
	xfs_repair: checking rt free space metadata must happen during phase 4 (Darrick J. Wong)
	xfs_db: allow setting current address to log blocks (Darrick J. Wong)
	xfs_db: convert rtsummary geometry (Darrick J. Wong)
	xfs_db: convert rtbitmap geometry (Darrick J. Wong)
	xfs_db: enable conversion of rt space units (Darrick J. Wong)
	xfs_db: access arbitrary realtime blocks and extents (Darrick J. Wong)
	xfs_db: access realtime file blocks (Darrick J. Wong)
	xfs_db: make the daddr command target the realtime device (Darrick J. Wong)
	xfs_db: report the realtime device when associated with each io cursor (Darrick J. Wong)
	xfs_db: support passing the realtime device to the debugger (Darrick J. Wong)
	xfs_io: add atomic file update commands to exercise file commit range (Darrick J. Wong)
	xfs_io: add a commitrange option to the exchangerange command (Darrick J. Wong)
	xfs_fsr: port to new file exchange library function (Darrick J. Wong)

xfsprogs-6.11.0 (19 Oct 2024)
	Cleanups and bugfixes in mkfs/xfs_db/repair/scrub/mdrestore (Darrick J. Wong)
	Drop libattr dependency (Darrick J. Wong)
	Debian and Ubuntu archive changes (Bastian Germann)

xfsprogs-6.10.1 (04 Sep 2024)
	fix C++ compilation errors in xfs_fs.h (Darrick J. Wong)

xfsprogs-6.10.0 (26 Aug 2024)
	debian: enable xfs_scrub_all systemd timer services by default (Darrick J. Wong)
	mkfs: set autofsck filesystem property (Darrick J. Wong)
	xfs_scrub: use the autofsck fsproperty to select mode (Darrick J. Wong)
	xfs_scrub: allow sysadmin to control background scrubs (Darrick J. Wong)
	xfs_property: add a new tool to administer fs properties (Darrick J. Wong)
	xfs_db: add a command to list xattrs (Darrick J. Wong)
	xfs_db: improve getting and setting extended attributes (Darrick J. Wong)
	xfs_io: edit filesystem properties (Darrick J. Wong)
	xfs_scrub: defer phase5 file scans if dirloop fails (Darrick J. Wong)
	xfs_repair: wipe ondisk parent pointers when there are none (Darrick J. Wong)
	xfs_scrub: detect and repair directory tree corruptions (Darrick J. Wong)
	xfs_repair: update ondisk parent pointer records (Darrick J. Wong)
	xfs_spaceman: report directory tree corruption in the health information (Darrick J. Wong)
	xfsprogs: support vectored scrub (Darrick J. Wong)
	man: document vectored scrub mode (Darrick J. Wong)
	man2: update ioctl_xfs_scrub_metadata.2 for parent pointers (Darrick J. Wong)
	mkfs: enable formatting with parent pointers (Allison Henderson)
	mkfs: Add parent pointers during protofile creation (Allison Henderson)
	xfs_repair: check parent pointers (Darrick J. Wong)
	xfs_db: compute hashes of parent pointers (Darrick J. Wong)
	xfs_db: add link and unlink expert commands (Darrick J. Wong)
	xfs_repair: build a parent pointer index (Darrick J. Wong)
	xfs_db: add a parents command to list the parents of a file (Darrick J. Wong)
	xfs_db: obfuscate dirent and parent pointer names consistently (Darrick J. Wong)
	xfs_db: report parent pointers embedded in xattrs (Darrick J. Wong)
	xfs_db: report parent bit on xattrs (Darrick J. Wong)
	xfs_db: report parent pointers in version command (Darrick J. Wong)
	xfs_scrub: use parent pointers to report lost file data (Darrick J. Wong)
	xfs_scrub: use parent pointers when possible to report file operations (Darrick J. Wong)
	xfs_logprint: decode parent pointers in ATTRI items fully (Allison Henderson)
	xfs_io: Add i, n and f flags to parent command (Allison Henderson)
	xfs_io: adapt parent command to new parent pointer ioctls (Darrick J. Wong)
	libfrog: report parent pointers to userspace (Darrick J. Wong)
	libfrog: add parent pointer support code (Darrick J. Wong)
	man: document the XFS_IOC_GETPARENTS ioctl (Darrick J. Wong)
	xfs_logprint: dump new attr log item fields (Darrick J. Wong)
	xfs_scrub_all: failure reporting for the xfs_scrub_all job (Darrick J. Wong)
	xfs_repair: check free space requirements before allowing upgrades (Darrick J. Wong)
	xfs_scrub_all: convert systemctl calls to dbus (Darrick J. Wong)
	xfs_scrub_all: trigger automatic media scans once per month (Darrick J. Wong)
	xfs_scrub: add an optimization-only mode (Darrick J. Wong)
	xfs_scrub_all: add CLI option for easier debugging (Darrick J. Wong)
	xfs_scrub_all: enable periodic file data scrubs automatically (Darrick J. Wong)
	xfs_scrub: automatic downgrades to dry-run mode in service mode (Darrick J. Wong)
	xfs_scrub_all: support metadata+media scans of all filesystems (Darrick J. Wong)
	xfs_scrub_all: fail fast on masked units (Darrick J. Wong)
	xfs_scrub_all: remove journalctl background process (Darrick J. Wong) 
	xfs_scrub_all: only use the xfs_scrub@ systemd services in service mode (Darrick J. Wong)
	xfs_scrub: tune fstrim minlen parameter based on free space histograms (Darrick J. Wong)
	xfs_scrub: improve responsiveness while trimming the filesystem (Darrick J. Wong)
	xfs_scrub: tighten up the security on the background systemd service (Darrick J. Wong)
	xfs_scrub: don't call FITRIM after runtime errors (Darrick J. Wong)
	xfs_scrub: use dynamic users when running as a systemd service (Darrick J. Wong)
	xfs_scrub: report FITRIM errors properly (Darrick J. Wong)
	xfs_scrub.service: reduce background CPU usage to less than one core if possible (Darrick J. Wong)
	xfs_scrub: don't close stdout when closing the progress bar (Darrick J. Wong)
	xfs_scrub: fix the work estimation for phase 8 (Darrick J. Wong)
	libfrog: print cdf of free space buckets (Darrick J. Wong)
	libfrog: print wider columns for free space histogram (Darrick J. Wong)
	xfs_scrub: ignore phase 8 if the user disabled fstrim (Darrick J. Wong)
	xfs_scrub: move FITRIM to phase 8 (Darrick J. Wong)
	xfs_scrub: improve thread scheduling repair items during phase 4 (Darrick J. Wong)
	xfs_scrub: avoid potential UAF after freeing a duplicate name entry (Darrick J. Wong)
	xfs_scrub: enable users to bump information messages to warnings (Darrick J. Wong)
	xfs_scrub: retry incomplete repairs (Darrick J. Wong)
	xfs_scrub: warn about difficult repairs to rt and quota metadata (Darrick J. Wong)
	xfs_scrub: any inconsistency in metadata should trigger difficulty warnings (Darrick J. Wong)
	mkfs: add a formatting option for exchange-range (Darrick J. Wong)
	xfs_repair: add exchange-range to file systems (Darrick J. Wong)
	xfs_scrub: fix missing scrub coverage for broken inodes (Darrick J. Wong)
	xfs_scrub: log when a repair was unnecessary (Darrick J. Wong)
	libfrog: advertise exchange-range support (Darrick J. Wong)
	xfs_io: create exchangerange command to test file range exchange ioctl (Darrick J. Wong)
	xfs_fsr: skip the xattr/forkoff levering with the newer swapext implementations (Darrick J. Wong)
	xfs_fsr: convert to bulkstat v5 ioctls (Darrick J. Wong)
	xfs_logprint: support dumping exchmaps log items (Darrick J. Wong)
	xfs_db: advertise exchange-range in the version command (Darrick J. Wong)
	libfrog: add support for exchange range ioctl family (Darrick J. Wong)
	libhandle: add support for bulkstat v5 (Darrick J. Wong)
	man: document XFS_FSOP_GEOM_FLAGS_EXCHRANGE (Darrick J. Wong)
	man: document the exchange-range ioctl (Darrick J. Wong)
	xfs_repair: don't crash on -vv (Darrick J. Wong)
	xfsprogs: Remove support for split-/usr installs (Chris Hofstaedtler)
	libxfs: kernel sync (Darrick J. Wong)
xfsprogs-6.9.0 (22 Jul 2024)
	xfs_db: Fix uninicialized error variable (Pavel Reichl)
	mkfs.xfs: avoid potential overflowing expression in xfs_mkfs.c (Bill O'Donnell)
	xfs_io: fix mread with length 1 mod page size (Eric Biggers)
	xfs_repair: detect null buf passed to duration (Darrick J. Wong)
	xfs_io: fix gcc complaints about potentially uninitialized variables (Darrick J. Wong)
	xfs_scrub: upload clean bills of health (Darrick J. Wong)
	xfs_spaceman: report health of inode link counts (Darrick J. Wong)
	xfs_repair: reduce rmap bag memory usage when creating refcounts (Darrick J. Wong)
	xfs_repair: log when buffers fail CRC checks even if we just recompute it (Darrick J. Wong)
	xfs_scrub: use multiple threads to run scrubs that scan inodes (Darrick J. Wong)
	xfs_scrub: update health status if we get a clean bill of health (Darrick J. Wong)
	xfs_repair: verify on-disk rmap btrees with in-memory btree data (Darrick J. Wong)
	xfs_scrub: check file link counts (Darrick J. Wong)
	xfs_scrub: implement live quotacheck inode scan (Darrick J. Wong)
	libxfs: provide a kernel-compatible kasprintf (Christoph Hellwig)
	xfs_spaceman: report the health of quota counts (Darrick J. Wong)
	libxfs: partition memfd files to avoid using too many fds (Darrick J. Wong)
	libxfs: add xfile support (Darrick J. Wong)
	libxfs: teach buftargs to maintain their own buffer hashtable (Darrick J. Wong)
	libxfs: kernel sync (Darrick J. Wong)
xfsprogs-6.8.0 (17 May 2024)
	xfs_repair: Dump both inode details in Phase 6 duplicate file check (Srikanth C S)
	libxfs: print the device name if flush-on-close fails (Darrick J. Wong)
	xfs_db: fix leak in flist_find_ftyp() (Andrey Albershteyn)
	xfs_repair: support more than INT_MAX block maps (Darrick J. Wong)
	xfs_repair: constrain attr fork extent count (Darrick J. Wong)
	xfs_repair: support more than 2^32 owners per physical block (Darrick J. Wong)
	xfs_repair: support more than 2^32 rmapbt records per AG (Darrick J. Wong)
	xfs_db: add a bmbt inflation command (Darrick J. Wong)
	xfs_scrub: scan whole-fs metadata files in parallel (Darrick J. Wong)
	mkfs: allow sizing internal logs for concurrency (Darrick J. Wong)
	mkfs: allow sizing allocation groups for concurrency (Darrick J. Wong)
	mkfs: use a sensible log sector size default (Christoph Hellwig)
	xfs_io: add linux madvise advice codes (Darrick J. Wong)
	xfs_scrub: fix threadcount estimates for phase 6 (Darrick J. Wong)
	xfs_db: improve number extraction in getbitval (Darrick J. Wong)
	xfs_repair: adjust btree bulkloading slack computations to match online repair (Darrick J. Wong)
	xfs: make rextslog computation consistent with mkfs (Darrick J. Wong)
	mkfs: fix log sunit rounding when external logs are in use (Darrick J. Wong)
	debian: fix package configuration (Darrick J. Wong)
	libxfs: kernel sync (Darrick J. Wong)
xfsprogs-6.7.0 (17 Apr 2024)
	xfsprogs: Several configure script updates (Christoph Hellwig)
	xfs_io: Use system's SEEK_DATA and SEEK_HOLE definition (Christoph Hellwig)
	xfsprogs: Remove platform_defs.h generation on build time (Christoph Hellwig)
	xfs_db: Fix metadata read error due hardcoded initialization of bb_count (Darrick J. Wong)
	debian: Increase build verbosity (Bastian Germann)
	xfsprogs: Request 64-bit time_t where possible (Sam James)
	xfsprogs: Remove use of LFS64 interfaces (Violet Purcell)

xfsprogs-6.6.0 (05 Feb 2024)
	xfsprogs: Several bug fixes (Darrick J. Wong)
	xfs_scrub: add missing license and copyright information (Darrick J. Wong)
	xfs_db: report the device associated with each io cursor (Darrick J. Wong)
	libxfs: Fix UAF in a requeued EFI (Darrick J. Wong)
	xfs_io: Add new option, to exercise log2_data_unit_size in kernel fscrypt_policy_v2 (Eric Biggers)
	xfs_db: Add upport to read from external log device (Chandan Babu R)
	metadump: New metadump format (Chandan Babu R)
	xfs_quota: fix missing mount point warning (Pavel Reichl)

xfsprogs-6.5.0 (12 Oct 2023)
	libxfs: fix atomic64_t detection on x86_32 (Darrick J. Wong)
	libxfs: use XFS_IGET_CREATE when creating new files (Darrick J. Wong)
	libfrog: fix overly sleep workqueues (Darrick J. Wong)
	xfs_db: use directio for device access (Darrick J. Wong)
	libxfs: make platform_set_blocksize optional with directio (Darrick J. Wong)
	mkfs: add a config file for 6.6 LTS kernels (Darrick J. Wong)
	mkfs: enable reverse mapping by default (Darrick J. Wong)
	mkfs: enable large extent counts by default (Darrick J. Wong)
	xfs_db: create unlinked inodes (Darrick J. Wong)
	xfs_db: dump unlinked buckets (Darrick J. Wong)
	xfsprogs: don't allow udisks to automount XFS filesystems with no prompt (Darrick J. Wong)
	xfs_repair: fix repair failure caused by dirty flag being abnormally set on buffer (Wu Guanghao)

xfsprogs-6.4.0 (19 Jul 2023)
	xfs_db: expose the flag in rmapbt keys (Darrick J. Wong)
	xfs_repair: warn about unwritten bits set in rmap btree keys (Darrick J. Wong)
	xfs_repair: check low keys of rmap btrees (Darrick J. Wong)
	xfs_repair: always perform extended xattr checks on uncertain inodes (Darrick J. Wong)
	xfs_repair: fix messaging when fixing imap due to sparse cluster (Darrick J. Wong)
	xfs_repair: fix messaging in longform_dir2_entry_check_data (Darrick J. Wong)
	xfs_repair: fix messaging when shortform_dir2_junk is called (Darrick J. Wong)
	xfs_repair: don't log inode problems without printing resolution (Darrick J. Wong)
	xfs_repair: don't spray correcting imap all by itself (Darrick J. Wong)
	libxcmd: Fix crash due to missing return value check on add_command() (Weifeng Su)
	xfs_db: make the hash command print the dirent hash (Darrick J. Wong)
	xfs_db: Add new cmd to create dirents and xattrs that induce dahash collisions (Darrick J. Wong)
	mkfs: deprecate the ascii-ci feature (Darrick J. Wong)
	xfs_db: fix metadump name obfuscation for ascii-ci filesystems (Darrick J. Wong)
	libxfs: kernel sync

xfsprogs-6.3.0 (22 May 2023)
	xfs_repair: Don't leak buffer when discarding directories (Darrick J. Wong)
	xfs_repair: estimate per-AG btree slack better (Darrick J. Wong)
	xfs_db: fix broken logic in error path (Darrick J. Wong)
	xfsprogs: nrext64 option is now in [inode] section of mkfs conf files (Eric Sandeen)

xfsprogs-6.2.0 (24 Mar 2023)
	xfs_repair: fix incorrect dabtree hashval comparison (Darrick J. Wong)
	mkfs: protofile can now create directories with spaces  in their names (Darrick J. Wong)
	mkfs: check dirent names when reading protofile (Darrick J. Wong)
	xfs_io: fix bmap command not detecting realtime files with xattrs (Darrick J. Wong)
	xfs_io: set fs_path when opening files on foreign filesystems (Darrick J. Wong)
	xfs_scrub: fix broken realtime free blocks unit conversions (Darrick J. Wong)
	xfs_spaceman: fix broken -g behavior in freesp command (Darrick J. Wong)
	xfs_admin: correctly parse IO_OPTS parameters (Catherine Hoang)
	Fix autoconf during debian package builds (Dave Chinner)
	xfs_admin: fsuuid cmd can now retrive UUID of mounted filesystems (Catherine Hoang)

xfsprogs-6.1.1 (13 Jan 2023)
	- scrub: fix warnings/errors due to missing include (Holger Hoffstatte)
	- debian: Add missing pkg version to the changelog (Carlos Maiolino)

xfsprogs-6.1.0 (23 Dec 2022)
	- libxfs: kernel sync
	- libxfs: consume the xfs_warn mountpoint argument (Darrick J. Wong)
	- misc: add static to various sourcefile-local functions (Darrick J. Wong)
	- misc: add missing includes (Darrick J. Wong)
	- xfs_{db,repair}: fix XFS_REFC_COW_START usage (Darrick J. Wong)
	- xfs_repair: don't crash on unknown inode parents in dry run mode (Darrick J. Wong)
	- xfs_repair: retain superblock buffer to avoid write hook deadlock (Darrick J. Wong)
	- xfs_repair: Attempt log replay during boot time repair (Srikanth C S)
	- xfs_repair: covscan fixes (Carlos Maiolino)
	- xfs_db: create separate struct and field definitions for finobts (Darrick J. Wong)
	- xfs_db: fix dir3 block magic check (Darrick J. Wong)
	- xfs_db: fix octal conversion logic (Darrick J. Wong)
	- xfs_db: fix printing of reverse mapping record blockcounts (Darrick J. Wong)
	- xfs_io: don't display stripe alignment flags for rt files (Darrick J. Wong)
	- xfs_db: fix dir3 block magic check (Darrick J. Wong)
	- mkfs.xfs: add mkfs config file for the 6.1 LTS kernel (Darrick J. Wong)

xfsprogs-6.0.0 (11 Nov 2022)
	- libxfs: kernel sync
	- xfs_db: use preferable macro to seek offset for local dir3 (Xiaole He)
	- xfs_quota: optimize -L/-U calls for dump/report (Andrey Albershteyn)

xfsprogs-5.19.0 (12 Aug 2022)
	- xfs_repair: fix printf format specifiers on 32-bit (Darrick J. Wong)

xfsprogs-5.19.0-rc1 (05 Aug 2022)
	- libxfs: last bit of kernel sync
	- libxfs: Fix MAP_SYNC build failure on MIPS/musl (Darrick J. Wong)
	- mkfs: stop allowing tiny filesystems (Darrick J. Wong)
	- mkfs: complain about impossible log size constraints (Darrick J. Wong)
	- mkfs: ignore stripe geometry for small filesystems (Darrick J. Wong)
	- mkfs: update manpage of bigtime and inobtcount (Zhang Boyang)
	- mkfs: document large extent count in --help screen (Darrick J. Wong)
	- mkfs: fix segfault with incorrect options (Darrick J. Wong)
	- xfs_repair: Support upgrade to large extent counters (Chandan Babu R)
	- xfs_repair: check geometry before upgrades (Darrick J. Wong)
	- xfs_repair: ignore empty xattr leaf blocks (Darrick J. Wong)
	- xfs_repair: check rt summary/bitmap vs observations (Darrick J. Wong)
	- xfs_repair: check free rt extent count (Darrick J. Wong)
	- xfs_repair: detect/fix changed fields w/ nrext64 (Darrick J. Wong)
	- xfs_repair: clear DIFLAG2_NREXT64 w/o fs support (Darrick J. Wong) 
	- xfs_repair: ignore log_incompat inconsistencies (Darrick J. Wong)s
	- xfs_repair: rewrite secondary supers w/ needsrepair (Darrick J. Wong)
	- xfs_db: id the minlogsize transaction reservation (Darrick J. Wong)

xfsprogs-5.19.0-rc0 (22 Jun 2022)
	- libxfs changes merged from kernels 5.18 and 5.19-rc
	- mkfs: option to create with large extent counters (Chandan Babu R)
	- xfs_info: Report NREXT64 feature status (Chandan Babu R)
	- xfs_logprint: Log item printing for ATTRI & ATTRD (Allison Henderson)

xfsprogs-5.18.0 (03 Jun 2022)
	- xfsprogs: more autoconf modernisation (Darrick J. Wong)

xfsprogs-5.18.0-rc1 (27 May 2022)
	- mkfs: Fix memory leak (Pavel Reichl)
	- mkfs: don't trample the gid set in the protofile (Darrick J. Wong)
	- mkfs: various post-log-size-increase fixes (Darrick J. Wong)
	- xfs_scrub: various enhancements and fixes (Darrick J. Wong)
	- xfs_scrub: move to mallinfo2 when available (Darrick J. Wong)
	- metadump: be careful zeroing corrupt inode forks (Dave Chinner)
	- metadump: handle corruption errors without aborting (Dave Chinner)
	- metadump: warn about suspicious finobt trees (Darrick J. Wong)
	- xfs_repair: check ftype of . and . directory entries (Darrick J. Wong)
	- xfs_repair: detect v5 feature mismatch in backup sb ((Darrick J. Wong)
	- xfs_repair: fix sizing of the incore rt space usage map calculation
	- xfs_repair: warn about bad btree levels in AG hdrs (Darrick J. Wong)
	- xfs_io: add a quiet option to bulkstat (Dave Chinner)
	- xfs_db: report maxlevels for each btree type (Darrick J. Wong)
	- xfs_db: support computing btheight for all cursors (Darrick J. Wong)
	- xfs_db: don't move cursor when switching types (Andrey Albershteyn)
	- docs: note the removal of XFS_IOC_FSSETDM (Darrick J. Wong)
	- xfsprogs: autoconf modernisation (Dave Chinner)
	- debian: support multiarch for libhandle (Darrick J. Wong)
	- debian: bump compat level to 11 (Darrick J. Wong)
	- debian: refactor common options (Darrick J. Wong)

xfsprogs-5.18.0-rc0 (06 May 2022)
	- libxfs changes merged from kernels 5.17 and 5.18

xfsprogs-5.16.0 (04 May 2022)
	- libxfs: remove kernel stubs from xfs_shared.h (Eric Sandeen)
	- debian: Generate .gitcensus instead of .census (Bastian Germann))

xfsprogs-5.16.0-rc0 (28 Apr 2022)
	- libxfs changes merged from kernel 5.16

xfsprogs-5.15.0 (06 Apr 2022)
	- mkfs: increase the min log size to 64MB when possible (Eric Sandeen)
	- xfs_scrub: retry items that are ok except for XFAIL (Darrick J. Wong)
	- xfs_scrub: fix xfrog_scrub_metadata error reporting (Darrick J. Wong)

xfsprogs-5.15.0-rc1 (11 Mar 2022)
	- mkfs: enable inobtcount and bigtime by default (Darrick J. Wong)
	- mkfs: prevent corruption of suboption string values (Darrick J. Wong)
	- mkfs: document sample configuration file location (Darrick J. Wong)
	- mkfs: add configuration files for a few LTS kernels (Darrick J. Wong)
	- mkfs: add a config file for x86_64 pmem filesystems (Darrick J. Wong)
	- xfs_quota: don't exit on "project" cmd failure (Eric Sandeen)
	- xfs_repair: don't guess about failure reason in phase6 (Eric Sandeen)
	- xfs_repair: update 2ndary superblocks after upgrades (Darrick J. Wong)
	- xfs_scrub: fix reporting if we can't open devices (Darrick J. Wong)
	- xfs_scrub: report optional features in version (Darrick J. Wong)
	- libxcmd: use emacs mode for command history editing (Darrick J. Wong)
	- libfrog: always use the kernel GETFSMAP definitions (Darrick J. Wong)
	- mkfs.xfs(8): fix default inode allocator description (Eric Sandeen)
	- xfs_quota(8): fix up dump and report documentation (Eric Sandeen)
	- xfs_quota(8): document units in limit command (Eric Sandeen)
	- misc: add a crc32c self test to mkfs and repair (Darrick J. Wong)

xfsprogs-5.15.0-rc0 (03 Feb 2022)
	- libxfs changes merged from kernel 5.15

xfsprogs-5.14.2 (06 Dec 2021)
	- libxfs: move rogue fallthrough macro out of linux.h (Darrick J. Wong)

xfsprogs-5.14.1 (02 Dec 2021)
	- libxfs: fix atomic64_t for 32-bit architectures (Darrick J. Wong)
	- libfrog: fix crc32c self test code on cross builds (Darrick J. Wong)

xfsprogs-5.14.0 (19 Nov 2021)
	- debian: Fix FTBFS (Boian Bonev)
	- debian: Pass --build and --host to configure (Bastian Germann)
	- debian: Update Uploaders list (Bastian Germann)

xfsprogs-5.14.0-rc1 (12 Nov 2021)
	- xfsprogs: introduce liburcu support (Dave Chinner)
	- xfsprogs: convert atomic to uatomic (Dave Chinner)
	- xfsprogs: convert utilities to use "fallthrough;" (Darrick J. Wong)
	- libxfs: port xfs_set_inode_alloc from kernel (Darrick J. Wong)
	- mkfs: warn about V4 deprecation (Darrick J. Wong)
	- xfs_db: convert agresv to use for_each_perag (Darrick J. Wong)

xfsprogs-5.13.0 (20 Aug 2021)
	- No further changes

xfsprogs-5.13.0-rc1 (02 Aug 2021)
	- mkfs: validate rtextsz hint when rtinherit is set (Darrick J. Wong)
	- xfs_repair: invalidate dirhash when junking dirent (Darrick J. Wong)
	- xfs_repair: validate inherited rtextsz hint alignmt (Darrick J. Wong)
	- xfs_quota: allow truncate of grp & prj quota files (Darrick J. Wong)
	- xfs_io: allow callers to dump fs stats individually (Darrick J. Wong)
	- xfs_io: don't count fsmaps before querying fsmaps (Darrick J. Wong)
	- xfs_io: print header once when dumping fsmap in csv (Darrick J. Wong)
	- xfs_io: clean up the funshare command a bit (Darrick J. Wong)
	- xfs_io: fix broken funshare_cmd usage (Darrick J. Wong)

xfsprogs-5.13.0-rc0 (01 Jul 2021)
	- libxfs changes merged from kernel 5.13

xfsprogs-5.12.0 (21 May 2021)
	- No further changes

xfsprogs-5.12.0-rc1 (07 May 2021)
	- mkfs: don't default to too-large physical sector size (Jeff Moyer)
	- repair: phase 6 speedups (Dave Chinner, Gao Xiang)
	- man: Add dax mount option to man xfs(5) (Carlos Maiolino)
	- xfs_admin: pick up log arguments correctly (Darrick Wong)
	- xfs_growfs: support shrinking unused space (Gao Xiang)
	- libfrog: report inobtcount in geometry (Darrick Wong)
	- xfs_logprint: Fix buffer overflow printing quotaoff (Carlos Maiolino)
	- xfsprogs: include <signal.h> for platform_crash (Leah Neukirchen)
	- xfsprogs: remove BMV_IF_NO_DMAPI_READ flag (Anthony Iliopoulos)
	- workqueue: bound maximum queue depth (Dave Chinner)

xfsprogs-5.12.0-rc0 (12 Apr 2021)
	- libxfs changes merged from kernel 5.12

xfsprogs-5.11.0 (12 Mar 2021)
	- xfs_admin: don't hide xfs_repair output when upgrading (Darrick Wong)
	- man: document attr2, ikeep option deprecation in xfs.5 (Pavel Reichl)

xfsprogs-5.11.0-rc1 (23 Feb 2021)
	- mkfs: make use of xfs_validate_stripe_geometry() (Gao Xiang)
	- mkfs: fix wrong inobtcount usage error output (Zorro Lang)
	- xfs_repair: enable bigtime upgrade via repair (Darrick J. Wong)
	- xfs_repair: enable inobtcount upgrade via repair (Darrick J. Wong)
	- xfs_repair: set NEEDSREPAIR on first write (Darrick J. Wong)
	- xfs_repair: clear the needsrepair flag when done (Darrick J. Wong)
	- xfs_repair: check dquot id and type (Darrick J. Wong)
	- xfs_fsr: Verify bulkstat version in qsort's cmp() (Chandan Babu R)
	- xfs_fsr: Interpret args of qsort's cmp() correctly (Chandan Babu R)
	- xfs_scrub: load and unload libicu properly (Darrick J. Wong)
	- xfs_scrub: various fixes (Darrick J. Wong)
	- xfs_admin: support adding features to V5 filesystems (Darrick J. Wong)
	- xfs_admin: support filesystems with realtime devices (Darrick J. Wong)
	- man: mark all deprecated V4 format options (Darrick J. Wong)
	- misc: fix valgrind complaints (Darrick J. Wong)
	- xfs_db: disallow label/uuid setting if NEEDSREPAIR (Darrick J. Wong)
	- xfs_db: show NEEDSREPAIR in check & version commands (Darrick J. Wong)
	- xfs_db: add an ls command (Darrick J. Wong)
	- xfs_db: add a directory path lookup command (Darrick J. Wong)

xfsprogs-5.11.0-rc0 (12 Feb 2021)
	- libxfs changes merged from kernel 5.11
	- Debian packaging fixes (Bastian Germann)

xfsprogs-5.10.0 (11 Dec 2020)
	- xfs_repair: remove old code for mountpoint inodes (Anthony Iliopoulos)

xfsprogs-5.10.0-rc1 (04 Dec 2020)
	- xfsprogs: Add inode btree counter feature (Darrick Wong)
	- xfsprogs: Add bigtime feature for Y2038 (Darrick Wong)
	- xfsprogs: Polish translation update (Jakub Bogusz)
	- mkfs.xfs: Add config file feature (Dave Chinner)
	- mkfs.xfs: allow users to specify rtinherit=0 (Darrick Wong)
	- xfs_repair: simplify bmap_next_offset (Christoph Hellwig)
	- man: various manpage updates (Eric Sandeen)
	- libxfs: remove some old dead code (Dave Chinner)
	- libxfs: add realtime extent tracking (Darrick Wong)

xfsprogs-5.10.0-rc0 (17 Nov 2020)
	- libxfs changes merged from kernel 5.10

xfsprogs-5.9.0 (20 Oct 2020)
	- No further changes

xfsprogs-5.9.0-rc1 (13 Oct 2020)
	- mkfs.xfs: disallow creation of RT files from proto file (Darrick Wong)
	- mkfs.xfs: fix ASSERT on small device with stripe geom (Pavel Reichl)
	- xfs_repair: more fixes from fuzz-testing (Darrick Wong)
	- libhandle: fix potential unterminated string problem (Darrick Wong)
	- libhandle: libfrog: fix a potential null pointer deref (Darrick Wong)
	- man: install all manpages that redirect to another page (Darrick Wong)
	- man: fix ioctl_xfs_geometry manpage naming (Eric Sandeen)
	- xfsprogs: various realtime related fixes (Darrick Wong)
	- xfsprogs: ignore autofs mount table entries (Ian Kent)

xfsprogs-5.9.0-rc0 (17 Sep 2020)
	- libxfs changes merged from kernel 5.9
	- libxfs: make buffers track the per-ag structures (Darrick Wong)

xfsprogs-5.8.0 (04 Sep 2020)
	- xfs_db: set b_ops to NULL for types without verifiers (Eric Sandeen)

xfsprogs-5.8.0-rc1 (26 Aug 2020)
	- mkfs: allow setting dax flag on root directory (Darrick Wong)
	- xfs_quota: improve reporting and messages (Bill O'Donnell)
	- xfs_db: use correct inode to set inode type (Zorro Lang)
	- xfs_db: fix nlink usage in check (Darrick Wong)
	- xfs_db: report the inode dax flag (Darrick Wong)
	- man: update mkfs.xfs inode flag option documentation (Darrick Wong)
	- xfsprogs: move custom interface def'ns to new header (Eric Sandeen)

xfsprogs-5.8.0-rc0 (10 Aug 2020)
	- xfs_repair: check quota counters (Darrick Wong)
	- xfs_io: fix -D vs -R handling (Xiao Yang)
	- libxfs changes merged from kernel 5.8

xfsprogs-5.7.0 (24 Jul 2020)
	- xfs_io: Document '-q' option for sendfile command (Xiao Yang)

xfsprogs-5.7.0-rc1 (15 Jul 2020)
	- remove libreadline support (Christoph Hellwig)
	- xfs_quota: allow individual timer extension (Eric Sandeen)
	- xfs_quota: fix unsigned int id comparisons (Darrick Wong)
	- xfs_repair: fix progress reporting (Eric Sandeen)
	- xfs_repair: fix minrecs error during phase5 btree rebuild (Gao Xiang)
	- xfs_repair: add missing validations to match xfs_check (Darrick Wong)
	- xfs_repair: use btree bulk loading (Darrick Wong)
	- xfs_io: fix copy_range argument parsing (Eric Sandeen)
	- xfs_io: document -q option for pread/pwrite command (Xiao Yang)
	- xfs_metadump: man page fixes (Kaixu Xia)
	- xfs_db: fix crc invalidation segfault (Anthony Iliopoulos)

xfsprogs-5.7.0-rc0 (07 May 2020)
	- libxfs changes merged from kernel 5.7

xfsprogs-5.6.0 (14 Apr 2020)
	- xfs_scrub: don't set WorkingDirectory in systemd job (Darrick Wong)

xfsprogs-5.6.0-rc1 (08 Apr 2020)
	- xfsprogs: fix silently broken option parsing (Dave Chinner)
	- xfsprogs: various minor Coverity fixes (Darrick Wong)
	- xfs_repair: fix dir_read_buf use of libxfs_da_read_buf (Darrick Wong)
	- libxfs: check retval of device flush when closing (Darrick Wong)
	- xfs_io:  set exitcode on failure appropriately (Dave Chinner)
	
xfsprogs-5.6.0-rc0 (18 Mar 2020)
	- libxfs changes merged from kernel 5.6

xfsprogs-5.5.0 (13 Mar 2020)
	- xfsprogs: don't warn about packed members (Dave Chinner)

xfsprogs-5.5.0-rc1 (01 Mar 2020)
	- xfsprogs: don't redeclare globals provided by libraries (Eric Sandeen)
	- xfsprogs: actually check that writes succeeded (Darrick Wong)
	- mkfs.xfs: check root inode location (Darrick Wong)
	- mkfs.xfs: efficient block zeroing (Eric Sandeen)
	- xfs_repair: fix broken unit conv. in dir invalidation (Darrick Wong)
	- xfs_repair: fix bad next_unlinked field (Eric Sandeen)
	- xfs_repair: don't corrupt attr fork clearing forw/back (Darrick Wong)
	- xfs_repair: check root dir pointer before trashing it (Darrick Wong)
	- xfs_repair: try to fix sb_unit value from secondaries (Darrick Wong)
	- xfs_repair: join RT inodes to transaction only once (Eric Sandeen)
	- xfs_io: fix over/underflow handling in timespecs (Darrick Wong)
	- xfs_io: fix pwrite/pread length trunc on 32-bit systems (Darrick Wong)
	- xfs_io: fix copy_file_range length argument overflow (Darrick Wong)
	- xfs_io: support passing a keyring key to add_enckey (Eric Biggers)
	- xfs_scrub: fix reporting of EINVAL for online repairs (Darrick Wong)
	- man: document some missing xfs_db commands (Darrick Wong)
	- man: document the xfs_db btheight command  (Darrick Wong)
	- man: list xfs_io lsattr inode flag letters  (Darrick Wong)

xfsprogs-5.5.0-rc0 (22 Jan 2020)
	- libxfs changes merged from kernel 5.5

xfsprogs-5.4.0 (20 Dec 2019)
	- No further changes

xfsprogs-5.4.0-rc1 (17 Dec 2019)
	- mkfs.xfs: Notify about discard & make it interruptable (Pavel Reichl)
	- xfs_admin: support external log devices (Darrick Wong)
	- xfs_admin: enable online label getting and setting (Darrick Wong)

xfsprogs-5.4.0-rc0 (15 Nov 2019)
	- libxfs changes merged from kernel 5.4

xfsprogs-5.3.0 (15 Nov 2019)
	- No further changes

xfsprogs-5.3.0-rc2 (07 Nov 2019)
	- mkfs.xfs: use libxfs to write out AGs vs. open-coding (Darrick Wong)
	- mkfs.xfs: fix incorrect error message during AG init (Darrick Wong)
	- xfs_repair: better info when metadata updates fail (Darrick Wong)
	- xfs_growfs: allow mounted device node as argument (Eric Sandeen)
	- xfs_spaceman: always report sick metadata (Darrick Wong)
	- xfs_io: add a bulkstat command (Darrick Wong)
	- xfs_io: encrypt command enhancements (Eric Biggers)
	- xfs_io: expose FS_XFLAG_HASATTR flag (Amir Goldstein)
	- xfs_io: copy_file_range fixes (Jianhong Yin)
	- man: document several new ioctls (Darrick Wong)
	- xfs_scrub: copious rewriting (Darrick Wong)
	- libfrog: header moves, refactoring, updates (Darrick Wong)
	- libxfs: fix buffer refcounting (Darrick Wong)

xfsprogs-5.3.0-rc1 (28 Aug 2019)
	- rebase 5.3 branch on top of 5.2.1

xfsprogs-5.3.0-rc0 (16 Aug 2019)
	- libxfs changes merged from kernel 5.3

xfsprogs-5.2.1 (21 Aug 2019)
	- fix geometry calls for kernels older than 5.2 (Eric Sandeen)

xfsprogs-5.2.0 (09 Aug 2019)
	- libxfs: cosmetic changes to trans.c to match kernel (Eric Sandeen)

xfsprogs-5.2.0-rc0 (24 Jul 2019)
	- libxfs changes merged from kernel 5.2

xfsprogs-5.1.0 (19 Jul 2019)
	- No further changes

xfsprogs-5.1.0-rc1 (11 Jul 2019)
	- mkfs: enable reflink by default (Darrick Wong)
	- mkfs: fix stripe unit handling (Allison Collins)
	- mkfs: remove useless log options in usage() (Yang Xu)
	- mkfs: validate start and end of aligned logs (Darrick Wong)
	- xfs_quota: fix built-in help for project setup (Eric Sandeen)
	- xfs_io: allow passing an open file to copy_range (Amir Goldstein)
	- xfs_info: limit findmnt to mounted xfs filesystems (Amir Goldstein)
	- man: break out several ioctl man pages (Darrick Wong)
	- man: Fix an inconsistency in the mkfs man page (Alvin Zheng)
	- xfs_scrub: fix background-mode sleep throttling (Darrick Wong)
	- libxfs: sync up xfs_trans_inode.c with the kernel (Eric Sandeen)
	- libfrog: fix bitmap return values (Darrick Wong)
	- libfrog: don't set negative errno in conversion f'ns (Darrick Wong)

xfsprogs-5.1.0-rc0 (07 May 2019)
	- libxfs changes merged from kernel 5.1

xfsprogs-5.0.0 (03 May 2019)
	- xfs_db: scan all sparse inodes when using 'frag' (Jorge Guerra)
	- Fix build with newer statx headers (Eric Sandeen)

xfsprogs-5.0.0-rc1 (26 Apr 2019)
	- mkfs: validate extent size hint parameters (Darrick Wong)
	- xfs_repair: bump on-disk nlink when adding lost+found (Darrick Wong)
	- xfs_repair: reinitialize root directory nlink correctly (Darrick Wong)
	- xfs_repair: use lenient verifiers for half-fixed inodes (Darrick Wong)
	- xfs_repair: acct for btree shrinks when fixing freelist (Darrick Wong)
	- xfs_repair: better cli option parameter checking (Darrick Wong)
	- xfs_repair: fix deadlock due to failed inode flushes (Dave Chinner)
	- xfs_info: handle devices, mountpoints, and loop files (Darrick Wong)
	- xfs_metadump: fix symlink handling (Darrick Wong)
	- xfs_io: fix label parsing and validation (Darrick Wong)
	- xfs_io: print attributes_mask in statx (Darrick Wong)
	- xfs_scrub: fix Make targets which depend on builddefs (Darrick Wong)
	- xfs_scrub: check label for misleading characters (Darrick Wong)
	- xfs_scrub: parallelize based on storage not CPUS (Darrick Wong)
	- xfs_scrub: activate timer only after system is up (Darrick Wong)
	- libxfs: fix buffer & inode lifetimes (Darrick Wong)
	- misc: fix strncpy length complaints from gcc (Darrick Wong)
	- debian build & packaging fixes (Darrick Wong)
	- Merge libxfs from kernel 5.0

xfsprogs-4.20.0 (22 Feb 2019)
	- No further changes

xfsprogs-4.20.0-rc1 (08 Feb 2019)
	- mkfs.xfs: null-terminate symlinks created via protofile (Eric Sandeen)
	- xfs_repair: allow '/' in attribute names (Eric Sandeen)
	- xfs_repair: skip block reservation when fixing freelist (Darrick Wong)
	- xfs_repair: rebuild dir when nonroot blocks corrupt (Darrick Wong)
	- xfs_repair: int nonleaf finobt blocks with proper magic (Brian Foster)
	- xfs_repair: fix off by one error rebuilding high keys (Darrick Wong)
	- xfs_io: allow open file permissions to be changed (Dave Chinner)
	- xfs_io: open pipes in non-blocking mode (Dave Chinner)
	- xfs_metadump: multiple stale data zeroing fixes (Stefan Ring)
	- xfs_quota: allow reg files w/o prjinherit flag (Achilles Gaikwad)
	- xfs_db: properly decode finobt record w/ sparse inodes (Darrick Wong)
	- xfs_db: fix frag command to work w/ sparse inodes (Eric Sandeen)
	- xfs_scrub: move all executables to /usr/sbin (Darrick Wong)
	- xfs_scrub: handle totally empty inode chunks (Darrick Wong)
	- xfs.5 manpage: Remove barrier related options (Eric Sandeen)
	- xfs_io.8 manpage: rearrange command listings by section (Darrick Wong)
	- Remove generated scrub files under make clean (Eric Sandeen)
	- Skip scrub manpage install if not configured (Eric Sandeen)
	- Merge libxfs from kernel 4.20

xfsprogs-4.19.0 (09 Nov 2018)
	- Fix up debian subdir build w.r.t. CHECK_CMD (Darrick Wong)

xfsprogs-4.19.0-rc1 (02 Nov 2018)
	- Remove non-linux platforms (Eric Sandeen)
	- Remove retpoline support (Eric Sandeen)
	- Add sparse checking & related fixes/cleanups (Eric Sandeen)
	- Fix cross-platform building w.r.t. crc32selftest
	- libxfs: add agfl free deferred op type (Darrick Wong)
	- mkfs.xfs: discard only after all validations (Jan Tulak)
	- xfs_repair: fix segfault in longform_dir2_entry_check (Eric Sandeen)
	- xfs_repair: fix ASSERT in xfs_bunmapi (Eric Sandeen)
	- xfs_repair: fix readahead thread deadlock/stall (Eric Sandeen)
	- xfs_repair: avoid writing back all inodes (Dave Chinner)
	- xfs_repair: don't treat directory root LEAFN as corrupt (Dave Chinner)
	- xfs_io: add crc32 self test (Darrick Wong)
	- xfs_io: remove useless do_preadv and do_pwritev arguments (Zorro Lang)
	- xfs_scrub: make scrub build config-optional (Eric Sandeen)
	- xfs_scrub: lack of kernel support is not a service failure (Darrick Wong)
	- xfs_scrub_all: fix systemd escaping (Darrick Wong)

xfsprogs-4.19.0-rc0 (10 Oct 2018)
	- Majority of 4.19 libxfs changes merged from kernel
	- Big sparse static checker cleanup (Eric Sandeen)
	- mkfs.xfs discard fixes (Jan Tulak)
	- xfs_io readv/writev cleanup (Zorro Lang)
	- libxfs transaction commit error checking (Darrick Wong)

xfsprogs-4.18.0 (24 Aug 2018)
	- Tweak SPDX license in xfs_cksum.h (Darrick Wong)

xfsprogs-4.18.0-rc1 (01 Aug 2018)
	- xfs_repair: notify user if free inodes are corrupt (Eric Sandeen)
	- xfs_repair: use extent size validation helpers (Darrick Wong)
	- xfs_quota: don't stop the directory tree walk at DEPTH (Kazuya Mio)
	- xfs_scrub: ongoing updates (Darrick Wong)
	- xfs_io: document shutdown -f (Carlos Maiolino)
	- xfs_io: wire up online repair ioctls (Darrick Wong)
	- misc: adddebian initramfs hook to package (Darrick Wong)
	- misc: remove unused macros (Eric Sandeen)
	- misc: remove many XFS_BUF macros (Carlos Maiolino)
	- misc: convert to SPDX license tags (Dave Chinner)

xfsprogs-4.18.0-rc0 (05 Jul 2018)
	- Majority of 4.18 libxfs changes merged from kernel

xfsprogs-4.17.0 (28 Jun 2018)
	- No further changes

xfsprogs-4.17.0-rc1 (22 Jun 2018)
	- mkfs.xfs: only stat block devices during mkfs init (Eric Sandeen)
	- xfs_repair: multiple fixes and improvements (Darrick Wong)
	- xfs_repair: check and repair quota metadata (Eric Sandeen)
	- xfs_repair: fix shortform root inode parent (Marco Benatto)
	- xfs_db: don't ASSERT on unrecognized metadata (Carlos Maiolino)
	- xfs_db: add superblock info command ala xfs_info (Darrick Wong)
	- xfs_spaceman: add superblock info command ala xfs_info (Darrick Wong)
	- xfs_info: call xfs_db for unmounted devices (Darrick Wong)
	- xfs_io: add online label command (Eric Sandeen)
	- xfs_io: add O_PATH and O_NOFOLLOW options (David Howells)
	- xfs_io: recognize *iB units in copy_range (Goldwyn Rodrigues)

xfsprogs-4.16.1 (30 Apr 2018)
	- fsck.xfs: remove bashism which may interfere with boot (Eric Sandeen)

xfsprogs-4.16.0 (25 Apr 2018)
	- No further changes

xfsprogs-4.16.0-rc1 (12 Apr 2018)
	- platforms: warn of impending deprecation of irix, freebsd, darwin
	- mkfs.xfs : enable sparse inodes by default (Darrick Wong)
	- fsck.xfs: allow forced boot-time repairs using xfs_repair (Jan Tulak)
	- xfs_repair: new -e flag alters exit code for fixed errors (Jan Tulak)
	- xfs_repair: fix to allow zeroing of corrupt log (Xiao Yang)
	- xfs_repair: remove old dead code (Eric Sandeen)
	- xfs_io: fix operation time reporting (Dave Chinner)
	- xfs_io: add RWF_DSYNC support to pwrite (Dave Chinner)
	- xfs_io: support a basic extent swap command (Brian Foster)
	- xfs_scrub: Many updates, still experimental (Darrick Wong)
	- xfs_db: print transaction reservation type information
	- libxfs: framework to detect memory leaks (Eric Sandeen)
	- misc: Fix up new warnings from gcc 7.3 (Darrick Wong)
	- misc: enable link time optimization, if requested (Darrick Wong)
	- misc: enable retpolines across all xfsprogs utilities (Darrick Wong)

xfsprogs-4.15.1 (26 Feb 2018)
	- debian: add build-depends on pkg-config (Darrick Wong)
	- debian: don't fail postinst when upgrading chroot (Darrick Wong)
	- update Polish translation (Jakub Bogusz)

xfsprogs-4.15.0 (23 Feb 2018)
	- various debian-related packaging fixes (Nathan Scott)

xfsprogs-4.15.0-rc1 (13 Feb 2018)
	- xfs_scrub: experimental new tool added (Darrick Wong)
	- xfs_metadump: fix issues with -i flag (Marco Benatto)
	- mkfs.xfs: don't allow creation of realtime+reflink (Darrick Wong)
	- mkfs.xfs: don't crash on dswidth overflow (Darrick Wong)
	- mkfs.xfs: much refactoring (Dave Chinner)
	- xfs_copy: fix copy of v5 filesystems (Eric Sandeen)
	- xfs_io: add a new 'log_writes' command (Ross Zwisler)
	- xfs_io: add MAP_SYNC support to mmap() (Ross Zwisler)
	- libxfs: memory zone handling cleanups (Eric Sandeen)

xfsprogs-4.14.0 (27 Nov 2017)
	- no changes from v4.14.0-rc2

xfsprogs-4.14.0-rc2 (20 Nov 2017)
	- xfs_repair: fix deadlock on failed refcountbt checks (Darrick Wong)
	- xfs_repair: fix cowextsize field checking and repairing (Darrick Wong)
	- xfs_repair: clear DAX flag from non-file inodes (Darrick Wong)
	- xfs_repair: fix bag memory overwrite problems (Darrick Wong)
	- xfs_metadump: zap stale data in DIR2_LEAF1 dirs (Eric Sandeen)
	- xfs_metadump: allow large directory extents by default (Darrick Wong)
	- xfs_copy: don't hang if all targets hit write errors (Darrick Wong)
	- xfs_io: stat: treat statfs.f_flags as optional (Jeff Mahoney)
	- xfs_io: stat: fix typo in statfs->f_flags (Jeff Mahoney)
	- xfs_io: Allow partial writes in pwrite (Goldwyn Rodrigues)
	- xfs_io: Add support for pwritev2() (Goldwyn Rodrigues)
	- xfs_io: Add RWF_NOWAIT to pwritev2() (Goldwyn Rodrigues))
	- xfs_io: Disable pwrite -V if pwritev unavailable (Goldwyn Rodrigues)
	- xfs_io: add new error injection knobs to inject command (Darrick Wong)
	- xfs_io: report io errors from pwrite -W and -w (Liu Bo)

xfsprogs-4.13.1 (26 Sep 2017)
	- fix global array overrun in mkfs (Darrick Wong)

xfsprogs-4.13.0 (26 Sep 2017)
	- no changes from v4.13.0-rc2

xfsprogs-4.13.0-rc2 (21 Sep 2017)
	- mkfs.xfs: pass custom cowextsize to created filesystem (Darrick Wong)
	- xfs_repair: handle missing extent states (Darrick Wong)
	- xfs_db: version command misses RMAPBT feature string (Zirong Lang)

xfsprogs-4.13.0-rc1 (15 Sep 2017)
	- mkfs.xfs: document forgotten flags (Darrick Wong)
	- mkfs.xfs: don't stagger AG on single disk (Donald Douwsma)
	- xfs_repair: various threading fixes (Jeff Mahoney)
	- xfs_repair: validate symlink target length (Darrick Wong)
	- xfs_repair: fix error exit status with -v flag (Masatake YAMATO)
	- xfs_fsr: Fix uninitalized varable use aftger timeout (Jeff Mahoney)
	- xfs_io: fix fiemap -n documentation to match reality (Nikolay Borisov)
	- xfs_io: Allow lsattr & lsproj on foreign filesystems (Ross Zwisler)
	- xfs_io: Print filesystem statfs flags in statfs output (Carlos Maiolino)
	- xfs_io: add seek consistency checks (Andreas Gruenbacher)
	- xfs_db: Fix metadump redirection (Darrick Wong)
	- xfs_db: Add fuzz command (Darrick Wong)
	- xfsprogs: Fix multiple compiler warnings (Darrick Wong)

xfsprogs-4.12.0 (20 Jul 2017)
	 - mkfs.xfs: allow specification of 0 stripe width & unit (Eric Sandeen)
	 - xfs_db: redirect printfs when metadumping to stdout (Darrick Wong)
	 - libxfs: propagate transaction block reservations (Darrick Wong)
	 - xfs_db: properly set inode type (Eric Sandeen)

xfsprogs-4.12.0-rc2 (13 Jul 2017)
	- mkfs.xfs: minimum log size calculation fixes (Darrick Wong)

xfsprogs-4.12.0-rc1 (30 Jun 2017)
	- xfs_spaceman: new space management tool (Dave Chinner, Darrick Wong)
	- xfs_io: implement fsmap command (Darrick Wong)
	- xfs_repair: fix 512 sector image repair on 4k sector host (Zorro Lang)
	- xfs_growfs: ensure target is an active xfs mountpoint (Bill O'Donnell)
	- xfs_metadump: warn about corruption if log is dirty (Jan Tulak)
	- xfs_metadump: tag metadump with informational flags (Eric Sandeen)
	- xfs_db: fix 'type' command for interesting geoms (Bill O'Donnell)
	- xfs_db: add alignment filter to freesp command (Eric Sandeen)
	- libxfs: use crc32c slice-by-8 variant by default (Darrick Wong)
	- update Polish translation (Jakub Bogusz)

xfsprogs-4.11.0 (5 May 2017)
	- xfs_io: man page fixups (Zorro Lang)

xfsprogs-4.11.0-rc2 (2 May 2017)
	- xfs_db: add btree dumping command (Darrick Wong)
	- mkfs.xfs: change bare -m rmapbt,reflink to enable (Eric Sandeen)
	- xfs_io: document -d option, enable for dqblks & inodes (Darrick Wong)
	- xfs_io: minor statx fixes, updates (Chandan Rajendra, Gwendal Grignou)

xfsprogs-4.11.0-rc1 (4 Apr 2017)
	- xfs_io: add statx support (David Howells, Eric Sandeen)
	- xfs_io: fix "falloc -p" to pass KEEP_SIZE (Calvin Owens)
	- xfs_io: support shutdown on foreign filesystems (Darrick Wong)
	- xfs_repair: repair zero-sized symlinks (Brian Foster)
	- xfs_repair: warn about dirty log with -n option (Eric Sandeen)
	- xfs.5: document barrier mount option deprecation (Eric Sandeen)

xfsprogs-4.10.0 (6 Feb 2017)
	- build: fix __bitwise definitions vs kernel headers (Darrick Wong)
xfsprogs-4.10.0-rc1 (15 Feb 2017)
	- build: fix cross-compile (Gwendal Grignou)
	- remove old Irix support (Christoph Hellwig)
	- xfs_repair: various additional checks (Darrick Wong)
	- xfs_repair: document dirty log conditions (Darrick Wong)
	- xfs_repair: document exit codes (Zirong Lang)
	- xfs_io: fix building with musl (Ralph Sennhauser)
	- xfs_io: add set_encpolicy / get_encpolicy (Eric Biggers)
	- xfs_io: Fix command iteration (Dave Chinner)
	- xfs_io: fix missing syncfs command  (Amir Goldstein)
	- xfs_db: fix 'source' command when passed as a -c option (Darrick Wong)
	- xfs_logprint: handle log operation split of inode item (Hou Tao)
	- xfs_metadump: ignore empty attribute leaf (Eric Sandeen)
	- libxfs: don't OOM on corrupt agcount (Darrick Wong)

xfsprogs-4.9.0 (5 Jan 2017)
	- no changes from v4.9.0-rc1

xfsprogs-4.9.0-rc1 (22 Dec 2016)
	- add reflink and dedupe support (Darrick Wong)
	- Convert from off64_t to off_t (Felix Janda)
	- xfs_io: add command line option to start an idle thread (Amir Goldstein)
	- xfs_repair: junk leaf attribute if count == 0 (Eric Sandeen)
	- xfs_quota: handle wrapped id from GETNEXTQUOTA (Eric Sandeen)
	- xfs_repair: fix some potential null pointer deferences (Darrick Wong)
	- libxfs_apply: filtering fixes (Dave Chinner)

xfsprogs-4.8.0 (17 Oct 2016)
	- no changes from v4.8.0-rc3

xfsprogs-4.8.0-rc3 (3 Oct 2016)
	- xfs_io: clean up inode command (Eric Sandeen)
	- xfs_repair: fix phase 5 btree size overestimation (Darrick Wong)
	- xfs_repair: fix phase 5 AGFL rmap update (Darrick Wong)
	- libxfs: libxfs_iget() cleanup (Eric Sandeen)
	- libxcmd: fix count of XFS filesystems in path table (Eryu Guan)

xfsprogs-4.8.0-rc2 (23 Sep 2016)
	- xfs_copy: uuid handling fixes (Eric Sandeen)
	- xfs_repair: directory rebuild segfault fix (Eric Sandeen)
	- xfs_repair: report log dirtiness correctly (Eric Sandeen)
	- libxfs: mounted filesystem detection cleanups (Eric Sandeen)
	- xfs_logprint: don't print transaction types anymore (Hou Tao)
	- xfs_quota: allow operation on non-XFS filesystems (Bill O'Donnell)
	- xfs_io: allow project quota operations on non-XFS (Eric Sandeen)
	- mkfs.xfs: man page calrification for ftype defaults (Eric Sandeen)

xfsprogs-4.8.0-rc1 (9 Sep 2016)
	- change contact emails to linux-xfs@vger.kernel.org
	- libxfs: kernel sync up to 4.8-rc1
	- Initial reverse mapping support (Darrick Wong)
	- buffer lock trace analysis tool (Darrick Wong)
	- logprint: cleanups and fixes (Darrick Wong)
	- man page updates (various)
	- libxcmd: mount option parsing fixes (Darrick Wong)
	- xfs_quota: use XFS_GETQSTATV (Eric Sandeen)
	- xfs_quota: allow use on non-XFS filesystems (Bill O'Donnell)
	- xfs_db: allow direct manipulation of CRCs (Eric Sandeen)
	- libxfs: get rid of ustat() calls (Felix Janda)

xfsprogs-4.7.0 (5 Aug 2016)
	- xfs_io: man page for copy_file_range (Anna Schumaker)
	- xfs_quota: handle XFS_GETNEXTQUOTA failure sanely (Zorro Lang)
	- mkfs: remove old glibc build failure workaround (Felix Janda)

xfsprogs-4.7.0-rc2 (20 Jul 2016)
	- xfs_io: add support for copy_file_range (Anna Schumaker)
	- repair: fix exit value after low memory is detected (Zorro Lang)
	- repair: fix quota inode detection issue (Eric Sandeen)
	- fix coverity issues from 4.7-rc1 (Bill O'Donnell)

xfsprogs-4.7.0-rc1 (22 Jun 2016)
	- libxfs kernel sync up to 4.7-rc1
	- quota: new efficient iteration mechanism (Eric Sandeen)
	- quota: support usernames starting with digits (Zorro Lang)
	- xfs_io: mmap/mremap fixes (Zorro Lang)
	- build/translation fixes (Mike Frysinger)
	- repair: error messge cleanups (Eric Sandeen)
	- mkfs: table based option parsing (Jan Tulak, Eric Sandeen)
	- metadump: sector size support fixes (Eric Sandeen)
	- db: unaligned acces fixes (Eric Sandeen)
	- db: add CRC recalculation for corrupt blocks
	- db: fix array notation handling in print commands
	- db: Note that fragmenation factor is meaningless (Eric Sandeen)
	- repair: more efficient secondary superblock search (Bill O'Donnell)
	- quota: timer reporting corner case fixes (Eric Sandeen)
	- headers: struct fsxattr redifinition fixes (Christoph Hellwig)
	- man page updates (Eric Sandeen, Jan Tulak, Zorro Lang)
	- repair: RT summary inode rebuild fix (Eric Sandeen)
	- db: sparse inode check fixes (Brian Foster)

xfsprogs-4.5.0 (15 Mar 2016)
	- xfs_io: prevent divide-by-zero on random IO (Dmitry Monakhov)
	- xfs_db: dquot command documentation fixes (Eric Sandeen)
	- xfs_quota: better command line parsing and documentation
	  (Zorro Lang)

xfsprogs-4.5.0-rc1 (17 Feb 2016)
	- libxfs: update to match kernel 4.5-rc1 code base
	- xfs_io: add DAX inode flag support
	- repair: scalability improvements on large corrupt filesystems
	- repair: directory rebuild fixes
	- mdrestore: progress accounting now works
	- metadump: fix btree block unused region zeroing
	- quota: timer command fixes (Eric Sandeen)
	- mkfs: man page cleanups (Eric Sandeen)
	- xfs_io: reflink, dedupe and other fixes (Darrick Wong)
	- quota: Q_XGETNEXTQUOTA support (Eric Sandeen)
	- build cleanups for alternate C librarys (Joshua Kinard, Felix Janda)
	- db: check fixes for sparse inodes (Darrick Wong)
	- various: Fixes for Coverity reports (Vivek Trivedi)
	- xfs_io: Document zero and help commands (Eric Sandeen)
	- mkfs: DIO can use logical sector size limits (Eric Sandeen)
	- repair: don't reset log cycle numbers when zeroing (Brian Foster)
	- db: add ability to format log to a specific cycle (Brian Foster)

xfsprogs-4.3.0 (23 Nov 2015)
	- xfs_fsr: cleanups to recent changes (Eric Sandeen)
	- xfs_fsr: improved temp file attr fork handling (Eric Sandeen)
	- libxfs: output verifier names in warnings (Eric Sandeen)
	- xfs_repair: enable verifier corruption warnings on very verbose
	  output settings (Eric Sandeen)
	- debian: update initramfs in postinst script (Steve McIntyre)

xfsprogs-4.3.0-rc2 (10 Nov 2015)
	- xfs_fsr: abstract mntinfo/mntent differences (Jan Tulak)
	- xfs_io: update reflink/dedupe ioctl definitions and implementation
	  (Darrick Wong)
	- libxcmd: factoring of runtime reporting (Darrick Wong)
	- man page fixes (Ville Skyttä)
	- removal of ASSERT from exported headers

xfsprogs-4.3.0-rc1 (14 Oct 2015)
	- xfs_io: reflink and dedupe operation support (Darrick Wong)
	- xfs_db: blockget/blocktrash support for v5 filesystems
	  (Darrick Wong)
	- xfs_repair: many directory/attr cleanups and fixes (Eric Sandeen)
	- More OS X build improvements (Jan Tulak)
	- Log zeroing rework for v5 filesystems to prevent log sequence
	  numbers from going backwards (Brain Foster)

xfsprogs-4.2.0 (7 Sep 2015)
	- repair: fix crashes due to missing geometry pointer (Eric Sandeen)
	- repair: fix node handling on large attribute btrees (Brian Foster)
	- repair: attribute block header verification fixes (Darrick Wong)
	- libxfs: more error negation fixes (Darrick Wong)
	- libxfs: cancelled readahead buffer state initialisation fixes
	  (Darrick Wong)
	- build: include/xfs header path fix (Lucas Stach)

xfsprogs-4.2.0-rc3 (25 Aug 2015)
	- xfs_repair: directory verification fixes (Darrick Wong)
	- libxfs: errno negation fixes (Darrick Wong)
	- xfs_db: corrupt inode handling fixes (Darrick Wong)
	- repair: memory leak fixes (Eric Sandeen)
	- libxfs: directory corruption fix (Jan Kara)
	- libxfs: gcc miscompile fixes (Jan Kara)
	- libxfs: merge across bug fixes from 4.2 kernel code
	- man pages: minor updates (Eric Sandeen)

xfsprogs-4.2.0-rc2 (18 Aug 2015)
	- OS X build improvements (Jan Tulak)
	- libxfs: fix code miscompilation w/ gcc 4.8.3 (Jan Kara)
	- mkfs.xfs: default to using ftype=1 for all filesystems
	- mkfs.xfs: CLI options parsing order fix (Eric Sandeen)
	- xfs_repair: improve inode version checks (Roger Willcocks)
	- libxfs: remove excessive EXPERIMENTAL feature warnings
	  for sparse inodes (Brian Foster)
	- xfs_db: fix new gcc 4.9.3 build warnings

xfsprogs-4.2.0-rc1 (4 Aug 2015)
	- update libxfs to match kernel 4.2-rc1
	- libxfs and include restructuring to match kernel code
	- sparse inode support (Brian Foster)
	- Android build support (Ted Tso)
	- Mac OS X build fixes (Jan Tulak)
	- changing UUIDs on v5 filesystems (Eric Sandeen)
	- libxfs-apply script for keeping kernel/progs libxfs in sync
	  (Eric Sandeen)
	- lots of header and type cleanups (Christoph Hellwig)
	- libblkid now mandatory (Jan Tulak)
	- lots of bug fixes (Brian Foster, Eric Sandeen, Christoph Hellwig,
	  Mike Grant)

xfsprogs-3.2.4 (30 Jul 2015)
	- xfs_metadump: information leakage fixes (CVE-2012-2150) (Eric Sandeen)

xfsprogs-3.2.3 (10 Jun 2015)
	- Debian packaging updates (Nathan Scott)

xfsprogs-3.2.3-rc2 (1 Jun 2015)
	- xfs_repair: handle speciall atribute names correctly (Eric Sandeen)
	- xfs_repair: handle v5 format feature flags correctly (Darrick Wong)
	- xfs_repair: Better v5 format validation for directories (Darrick Wong)

xfsprogs-3.2.3-rc1 (11 May 2015)
	- mkfs.xfs: enable metadata CRCs by default
	- mkfs.xfs: enable free inode btrees by default
	- build: glibc support updates (Jan Tulak)
	- man page updates (Sage Weil, Namjae Jeon, Eric Sandeen)
	- xfs_admin: Changing UUIDs disable for CRC enabled filesystems
	  (Eric Sandeen)
	- xfs_repair: Separate pquota inode fixes (Brian Foster)
	- xfs_db: inode alignment fixes (Brian Foster)
	- mkfs.xfs: fix failures creating file images (Brian Foster)
	- libxfs: zero new buffers before use (Darrick J. Wong)
	- xfs_repair: handle directory leaf CRC errors gracefully
	  (Darrick J.  Wong)
	- xfs_repair: validate and repair inode CRCs (Eric Sandeen)
	- xfs_repair: lots of broken directory repair fixes (Eric Sandeen)
	- xfs_db: handle v3 inodes properly (Eric Sandeen)
	- xfs_db: allow writing corrupted metadata on CRC enabled filesystems
	  (Eric Sandeen)
	- xfs_repair: gracefully handle > 512 byte sector superblocks
	- mkfs.xfs: take into acocunt log stripe unit when sizing log
	- xfs_metadump: inode alignment and null inode fixes (Brian Foster)
	- xfs_io: FALLOC_FL_INSERT_RANGE support (Namjae Jeon)
	- build: libtool static library build fixes (Romain Naour)
	- mkfs.xfs: large block size inode alignment fixes (Brian Foster)
	- xfs_repair: secondary superblock scan fixes (Brian Foster)
	- xfs_repair: don't care about symlink compenent lengths
	  (Eric Sandeen)

xfsprogs-3.2.2 (4 December 2014)
	- Debian packaging updates (Nathan Scott)
	- xfs_repair, mkfs.xfs stripe geometry fixes (Eric Sandeen)
	- libxcmd path handling fixes (Eric Sandeen)
	- xfs_crash crash fix (Jie Liu)
	- xfs_logprint AGI/AGF handling improvements (Jan Kara)
	- libhandle support for symlinked /usr (Jan Tulak)
	- fix multiple Coverity and sparse reported issues (Eric Sandeen)
	- new mremap, sync, syncfs commands for xfs_io (Eric Sandeen)
	- man page updates (Eric Sandeen, Mark Tinguely)
	- xfs_repair sets ftype in lost+found dirents (Jan Kara)
	- xfs_repair handles bad inodes better (Eric Sandeen)
	- xfs_repair freelist rebuild improvements
	- xfs_repair finobt crash fixes (Brian Foster)
	- xfs_copy handles 4k sector devices better (Eric Sandeen)

xfsprogs-3.2.1 (15 July 2014)
	- Added support for new on-disk free inode btree (Brian Foster)
	- libxfs inode use-after free fixes (Mark Tinguely)
	- xfs_copy threading cleanups (Junxiao Bi)
	- xfs_check has been removed
	- C++ header compiler fixes (Roger Willcocks)
	- xfs_repair prefetch fixes (Eric Sandeen)
	- xfs_repair directory block CRC detection fixes (Jan Kara)
	- xfs_repair directory rebuild fixes
	- libxfs buffer error handling fixes
	- xfs_repair quota inode handling fixes
	- removed incorrect asserts from phase 2 of xfs_repair
	- updated Polish translations (Jakub Bogusz)
	- xfs_mkfs 4k sector device fixes (Eric Sandeen)
	- xfs_fsr cleanups nd fixes (Eric Sandeen)
	- mount options described in xfs(5) man page (Eric Sandeen)

xfsprogs-3.2.0 (16 May 2014)
	- First release with full support of CRC enabled filesystems
	- No code changes from 3.2.0-rc3

xfsprogs-3.2.0-rc3 (9 May 2014)
	- Third release candidate for full support of CRC enabled filesystems
	- Updated Debian change logs in preparation for release (Nathan Scott)
	- Build warning fixes (Nathan Scott)
	- xfs_repair prefetch fix (Eric Sandeen)
	- xfs_repair block tracking scalability fix

xfsprogs-3.2.0-rc2 (2 May 2014)
	- Second release candidate for full support of CRC enabled filesystems
	- xfs_repair has full CRC validation and repair
	- Coverity related cleanups and fixes

xfsprogs-3.2.0-rc1 (14 April 2014)
	- First release candidate for full support of CRC enabled filesystems
	- Large number of Coverity related fixes and cleanups
	- disambiguous of CRC validation errors from IO errors.
	- Improved dangerous mode handling in repair
	- repair handles garbage in zeroed areas of superblocks better
	- repair validates dirent ftype field fully
	- metadump fully supports discontiguous directory blocks
	- metadump only recalculates CRCs on metadata it obfuscates so as to
	  preserve errors in the metadata where possible.
	- default log size that mkfs creates is now reverted to the same size
	  as 3.1.x releases create.
	- mkfs sets the ftype on directory entries correctly during protofile
	  population
	- xfs_io support O_TMPFILE, flink, FALLOC_FL_ZERO_RANGE and
	  FALLOC_FL_COLLAPSE_RANGE,
	- logprint handles split entries better

xfsprogs-3.2.0-alpha2 (25 November 2013)
	- Alpha release for the purpose of testing the CRC feature in
	  kernels 3.10 and newer.
	- Enable xfs_db write support and xfs_metadump support for CRC
	  enabled filesystems.
	- Add directory entry filetype support for non-CRC filesystems.
	- Remove experimental warnings for CRC filesystems.
	- Ensure all inodes created by xfs_repair have a proper d_type set.
	- Fix build on big endian machines.
	- Properly handle symlinks to devices on various tool commandlines.
	- Fix xfs_repair's dirty log detection for 4k sector logs, broken
	  in Alpha1.
	- Fix a potential segfault in xfs_repair when issuing progress 
	  reports.
	- Fix potential xfs_fsr failures when running w/ selinux.
	- Update config.guess/config.sub for arm64, thanks to Colin Watson.
	- Stop wasting memory by caching inode structures in xfs_repair -
	  they are never re-used.  Thanks to Christoph Hellwig.
	- Fix several Coverity-found defects, thanks to Li Zhong.
	- Fix platform_test_xfs_fd to return false on special files which
	  cannot take an xfs ioctl.
	- Sync up libxfs with kernel code.
	- Improved xfs_repair performance on large filesystems
	  (always use prefetch and strided AG scanning functionality)


xfsprogs-3.2.0-alpha1 (26 September 2013)
	- Alpha release for the purpose of testing the CRC feature in
	  kernels 3.10 and newer.
	- Remove all vestiges of old, unsupported version 1 directory code.
	- Add a "readdir" command to xfs_io, thanks to Brian Foster.
	- Fix potential segfault in xfs_repair when creating lost+found.
	- Zero out unused parts of on-disk superblocks during repair, to
	  avoid metadata verifier failures at runtime.
	- Add directory entry type support to mkfs.xfs and xfs_db.
	- Add the icreate transaction to xfs_logprint, and fix continuation
	  transactions.
	- Add the lseek SEEK_DATA/SEEK_HOLE support into xfs_io.
	- Print all AGI unlinked buckets in xfs_logprint.
	- Fix mkfs.xfs ENOSPC with protofile which creates a very large
	  directory.
	- Fix several Coverity-found defects, thanks to Li Zhong.
	- Do all file reads in xfs_fsr using O_DIRECT.
	- Sync up libxfs with kernel code.
	- Add support for concurrent group and project quota usage on CRC
	  enabled filesystems.
	- Ensure mkfs creates log sizes that are always large enough for
	  the configured fileystem geometry.

xfsprogs-3.1.11 (8 May 2013)
	- Support for relative paths in xfs_quota thanks to Satoru Takeuchi.
	- mkfs.xfs will always go into multidisk mode when filesystem
	  geometry is specified on the command line.
	- Document all commands in xfs_io.
	- Remove setfl command from xfs_io.
	- xfs_metadump will obfuscate symlinks by path component.
	- mkfs.xfs no longer accepts geometry settings smaller than the
	  physical sector size.
	- xfs_logprint now supports multiply-logged inode fields and
	  handles continued inode transactions correctly.
	- kill XLOG_SET
	- Update release scripts to use git archive to address a
	  missing source file reported by Arkadiusz Mi?kiewicz
	- Fix a build error with -Werror=format-security, reported
	  by Arkadiusz Mi?kiewicz
	- mkfs.xfs no longer attempts to discard when -N option is used.
	- Update 'make deb' to use tarball
	- Sync up with log reservation changes in the kernel.
	- Fix possible unallocated memory access in fiemap.
	- Guard against string overflow in path_to_fspath.
	- Fix setup_cursor array allocation.
	- Fix free of unintialized pointer in xfs_acl_valid error path.
	- Guard against path string overflows.
	- Check strdup results properly in initallfs().
	- Fix attribute no_change_count logic.
	- Remove extraneous close() in fsrallfs().
	- xfs_repair now skips the freelist scan of a corrupt agf
	  when in no-modify mode.
	- xfs_db now skips freelist scans of corrupt agfs.
	- Remove unconditional ASSERT(0) in xfs_repair.
	- Reduce bb_numrecs in bno/cnt btrees when log consumes all agf space.
	- Add depraction message for xfs_check.
	- xfs_quota allow user or group names beginning with digits reported
	  by James Carter.
	- Fix manpages and usage() spelling, errors and omissions.
	- Validate the extent count is at least within the positive
	  range of a signed 32 bit integer before using it.

xfsprogs-3.1.10 (13 December 2012)
	- Update release script to make a source tarball.

xfsprogs-3.1.9 (31 October 2012)
	- Print nice details if agsize is out of bounds in mkfs.xfs.
	- Various fixes for fragmented multi-block dir2 handling in
	  xfs_repair.
	- Fix extent record printing in xfs_db on big endian arches.
	- Use the correct macros when dumping block maps in extent
	  form in xfs_db, thanks to Peter Watkins.
	- Add sync file range support to xfs_io.
	- Implement preadv/pwritev in xfs_io.
	- Link against libreadline for libxcmd, thanks to Mike Frysinger.
	- Clean up mkfs.xfs output on invalid inode size.
	- Various build fixes, thanks to Mike Frysinger and Jan Engelhardt.

xfsprogs-3.1.8 (20 March 2012)
	- Fix xfs_repair segfault on a corrupted filesystem by validating the
	  acl count before reading it.
	- Avoid xfs_repair deadlocks on prefetched buffers.
	- Fix various incorrect printf formats, thanks to Jakub Bogusz for
	  reporting.
	- Polish translation update, thanks to Jakub Bogusz.
	- Refuse mkfs.xfs on misaligned devices when using 4k sectors, unless
	  the -f option is specified, and then force 512b sector size,
	  thanks to Carlos Maiolino.
	- Avoid a possible loop on the unlinked inode list in phase 3 of
	  xfs_repair, thanks to Stefan Pfetzing for reporting.
	- Allocate inode and free extent records individually in xfs_repair.
	- Fix a possible deadlock btree nodes in xfs_repair by using recursive
	  locking, thanks to Arkadiusz MiÅ›kiewicz for reporting and testing.
	- Fix possible xfs_repair deadlocks in inode prefetching, thanks to
	  Arkadiusz MiÅ›kiewicz for reporting and testing.
	- Make xfs_repair handle filesystems with the log in ag 0, thanks to
	  Sindre Skogen for reporting.
	- Deprecate the -F foreign flag to xfs_io.
	- Add debian linux-libc-dev build dependancy.
	- Add an extended fiemap configure check.
	- Various cleanups in xfs_repair.
	- Update xfs_check man page to recommend xfs_repair over xfs_check,
	  thanks to Arkadiusz MiÅ›kiewicz.
	- Update the on-disk extent count as part of inode repair when moving
	  inodes to lost+found to avoid to avoid tripping over a check in
	  xfs_iformat, thanks to Arkadiusz MiÅ›kiewicz for reporting and
	  testing.
	- Check for size parsing errors in xfs_quota, thanks to James Lawrie
	  for reporting.
	- Fix fiemap loop continuation in xfs_io.
	- Make mkfs.xfs properly handle physical sector size.
	- Fix /proc/mounts parsing in xfs_fsr.
	- Fix xfs_repair when ag_stride options with attributes and dirv1 code,
	  thanks to Tom Crane for reporting and testing.
	- Fix message formats in process_dinode_int.
	- Fix xfs_repair handling of link counts when the on-disk count
	  overflows 8 bits.
	- Fix messages from set_nlinks in xfs_repair.

xfsprogs-3.1.7 (17 November 2011)
	- Pull in fix for debian/control
	- Polish translation update, thanks to Jakub Bogusz
	- Fix xfs_repair link count on lost+found, thanks to Carlos Maiolino
	- Fix various incorrect printf formats

xfsprogs-3.1.6 (14 October 2011)
	- Re-synch of the header and libxfs files with the kernel
	  code as of Linux 2.6.37, including reviving xfs_repair
	  radix tree code.
	- Fix a xfs_repair phase 4 hang, thanks to Ajeet Yadav.
	- Subcommand names within various programs are no longer
	  translated/localized, thanks to Arkadiusz Mi?kiewicz.
	- Build system fixes, thanks to Ted Ts'o.
	- Updates to teh xfs_info(8)/xfs_growfs(8) man page, thanks
	  to Roman Ovchinnikov.
	- xfs_quota "df" no longer reports values twice what they
	  should have been for project quotas.
	- mkfs.xfs now requires that sub-options are non-empty
	  strings; thanks to Chris Pearson for reporting.
	- Better handling of short reads in libxfs.
	- xfs_quota now prints "N/A" rather than a large number for
	  the quota file inode number for disabled quota types.
	- Bogus (unrelated) mount point entries no longer cause
	  xfs_growfs, xfs_quota, and xfs_io to quit early.
	- xfs_repair no longer fails when the sector size of an
	  underlying device is larger than the sector size in a
	  hosted filesystem image.
	- Various other internal improvements, including refactoring
	  and eliminating more build warnings.

xfsprogs-3.1.5 (30 March 2011)
	- Polish translation update, thanks to Jakub Bogusz
	- xfs_repair now warns if running in low memory mode
	- Phase 2 of xfs_repair is now multithreaded
	- xfs_quota no longer attempts to get quota information if
	  not enabled
	- Inode flags are now properly validated by xfs_repair
	- Metadump now obfuscates all file names reliably
	- xfs_io now supports the "fiemap" command, a more generic
	  form of the "bmap" command
	- xfs_io now supports the "fpunch" command, as well as a
	  "-p" flag to the "fallocate command.  Both implement hole
	  punching.  Thanks to Josef Bacik
	- A number of other bug fixes thanks to Ajeet Yadav

xfsprogs-3.1.4 (9 November 2010)
	- Add projid32bit handling to userspace, resolving type
	  sizing issues when dealing with 32 bit project ids.
	- Make xfs_fsr use /proc/mounts if available.
	- Annotate that Debian packages are group maintained.
	- Fix a Debian packaging issue causing upgrade pain.

xfsprogs-3.1.3 (26 August 2010)
	- Add xfs_io support for XFS_IOC_ZERO_RANGE
	- Fix depend targets.
	- Allow xfs_io resvsp command for foreign filesystems.
	- Fix configure --prefix.
	- Make xfs_db check for valid inode data pointer before dereferencing.
	- Validate btree block magic in the xfs_db freesp command,
	  thanks to Peter Watkins.
	- Unbreak make update-po, permissions problem,
	  thanks to Arkadiusz MiÅ›kiewicz.
	- Fix linking of libxfs and librt detection (needs pthread),
	  thanks to Arkadiusz MiÅ›kiewicz.
	- Add a platform_discard_blocks stub for GNU/kFreebsd.

xfsprogs-3.1.2 (6 May 2010)
	- Fix missing thread synchronization in xfs_repair duplicate
	  extent tracking.
	- Fix handling of dynamic attribute fork roots in xfs_fsr.
	- Fix sb_bad_features2 manipulations when tweaking the lazy count
	  flag.
	- Add support for building on Debian GNU/kFreeBSD, thanks
	  to Petr Salinger.
	- Improvements to the mkfs.xfs manpage, thanks to Wengang Wang.
	- Various small blkid integration fixes in mkfs.xfs.
	- Fix build against stricter system headers.

xfsprogs-3.1.1 (29 January 2010)
	- Fix various blkid topology support problems in mkfs.xfs.
	- Fix various build warnings.
	- Add automatic build dependency calculations.
	- Cleaner build system output.
	- Add missing aclocal m4 file to the package generation.
	- Arrange for release tags to be digitally signed.

xfsprogs-3.1.0 (13 January 2010)
	- Reduce memory usage in xfs_repair by using better data structures.
	- Add additional checks in xfs_repair to detect freespace btree
	  corruption instead of only rebuilding the btrees.  Useful for the
	  no-modify mode.
	- Fix libhandle to use the right path to issue by-handle ioctls for
	  symbolic links and special files.
	- Use lazy superblock counters by default.  At least kernel 2.6.22 is
	  needed for this feature.
	- Use physical device sector size if available in mkfs.xfs,
	  so 4K sector devices are handed more gracefully.
	- Add a German translation, thanks to Chris Leick.
	- Enable the madvise and mincor commands in xfs_io.
	- Fix unsafe temporary file creation in xfs_fsr.
	- Add support for discarding unused space on SSDs or thin provisioned
	  arrays in mkfs.xfs.
	- Allow linking against libblkid for topology information.
	- Add symbol versioning for libhandle.
	- Remove the included RPM and binary tarball built infrastructure.
	- Various build system improvements.
	- Small fixes to xfs_db and xfs_io.

xfsprogs-3.0.4 (17 September 2009)
	- Fix a memory leak in xfsprogs.
	- Increase hash chain length in xfsprogs when running out of memory.
	- Fix dmsetup invocation in libdisk to avoid warnings during mkfs
	  on multipath devices.
	- Fix the -V option to various installed tools.
	- Small internal fixes to please the clang semantical analysis tool.
	- Debian packaging updates.
	- Rework Makepkgs and Makefiles to improve deb generation.

xfsprogs-3.0.3 (30 August 2009)
	- Fix unaligned accesses in libxfs.
	- Various small fixes to xfs_db, xfs_repair and xfs_io.
	- Add fallocate command to xfs_io.
	- Enable readline support in xfs_io and xfs_quota.
	- Allow log sizes up to 2GiB (minus 1 byte) in xfs_mkfs.
	- Open the block device in xfs_repair exclusively, thanks to
	  Nathaniel W. Turner.

xfsprogs-3.0.2 (6 May 2009)
	- Updates to Debian build process after recent autoconf tweaks.
	- Fix a couple of minor man page syntax issues.

xfsprogs-3.0.1 (4 May 2009)
	- Update the Makepkgs script to generate proper source tarballs.
	- New project(5) and projid(5) man pages.
	- Fix extent array reallocation in the xfs_io bmap command,
	  thanks to Tomasz Majkowski.
	- Small specfile improvements, thanks to Jan Engelhardt.
	- Allow xfs_freeze to freeze non-XFS filesystems.
	- Fix the xfs_db bmbta command.
	- Fix parallel builds, thanks to Mike Frysinger.
	- Various autoconf/libtool fixes, thanks to Andreas Gruenbacher.

xfsprogs-3.0.0 (4 February 2009)
	- Various smaller xfs_repair improvements.
	- Various gettext improvements, thanks to Jakub Bogusz.
	- Polish translation update, thanks to Jakub Bogusz.
	- Various xfs_quota fixes, thanks to Arkadiusz Miskiewicz.
	- Support parallel builds.
	- Detection of btrfs, gfs and gfs2 in libdisk.
	- Addition of the xfs_fsr and xfs_estimate tools previous found
	  in the xfsdump package.
	- Resync libxfs to latest kernel implemenation.
	- Update all of xfsprogs to latest kernel interfaces.
	- Add sparse support to xfsprogs build.
	- Cleanup devel package for xfsctl, libhandle and libdisk only
	  (remove libxfs interfaces).

xfsprogs-2.10.1 (5 September 2008)
	- Improve xfs_repair -P option to disable xfs_buf_t locking.
	- Fix inode cluster I/O size for > 8KB block size filesystems.
	- Fix up ASCII CI output for mkfs.xfs and xfs_growfs.
	- Fix buffer handling in error cases in xfs_db (includes xfs_check
	  and xfs_metadump).
	- Add packed on-disk shortform directory for ARM's old ABI, thanks to
	  Eric Sandeen.
	- Increase default valid block count for a directory extent in
	  xfs_metadump (from 20 to 1000).
	- Fix up mkfs.xfs -N option with "-d file" so it doesn't resize the
	  target file (thanks to Michal Marek).
	- Improve libxfs cache handling with (un)referenced blocks.
	- Check that directory size is not too big in xfs_repair.
	- Improve xfs_repair to restore bad or missing ".." entries.

xfsprogs-2.10.0 (26 May 2008)
	- Add ASCII case-insensitive support to xfsprogs.

xfsprogs-2.9.8 (21 April 2008)
	- Add support for sb_features2 in wrong location in mkfs.xfs,
	  xfs_repair and xfs_db.
	- Improve memory limits for libxfs cache in xfs_repair and added
	  a -m option to manually limit usage of xfs_repair.
	- Add -c option to xfs_admin to turn lazy-counters on/off.
	- Added support for mdp in libdisk/mkfs.xfs, thanks to
	  Hubert Verstraete.
	- Add -p option to fsck.xfs, thanks to Markus Rothe.
	- Cleanup sys v3 bzero/bcopy calls, thanks to Nigel Kukard.

xfsprogs-2.9.7 (1 Mar 2008)
	- Lazy superblock counters not yet the default with mkfs.xfs.
	- Add -y (another no-op) fsck option.
	- Resolve mkfs allocation group count issue with small devices.
	- Fix mkfs to sector align the device size so zeroing the end
	  of the device doesn't fail.

xfsprogs-2.9.6 (7 Feb 2008)
	- Fix regression introduced by changing the mkfs.xfs defaults.
	- Made lazy superblock counters the default with mkfs.xfs.

xfsprogs-2.9.5 (21 Jan 2008)
	- Updated mkfs.xfs defaults.
	- Make xfs_info handle mount points with spaces.
	- Improve xfs_repair's handling of invalid freespace btree extents.
	- Rebuild directories in xfs_repair if "." and ".." aren't the first
	  two directory entries. This guarantees a directory is deletable.
	- Changed mkfs.xfs -f to wipe all old AG headers, not just the ones
	  up to the end of the new filesystem size.
	- Purged the end of device whack buffer in mkfs.xfs to prevent a
	  warning in certain device sizes.
	- Man page fixes. Thanks to Utako Kusaka <u-kusaka@wm.jp.nec.com>
	  for this.
	- Disable the ability to turn off unwritten extents in mkfs.

xfsprogs-2.9.4 (7 Sep 2007)
	- Fixed xfs_repair segfaulting with directory block size different
	  to the filesystem blocksize.
	- Fixed xfs_quota disable, enable, off and remove commands.
	  Thanks to Utako Kusaka <utako@tnes.nec.co.jp> for this.
	- Improved the robustness of xfs_metadump.
	- Fix link issues with pthread library.

xfsprogs-2.9.3 (23 July 2007)
	- Make xfs_repair support > 512 byte sector sizes.
	- Fixed include Makefile for new common header (xfs_metadump.h).
	- Fixed xfs_quota state command segfaulting with no mounted
	  XFS filesystems.
	- Fixed xfs_quota printing out unusual message with "path n" command
	  with no mounted XFS filesystems.
	- Fixed "quota -n" command with project IDs.
	- Improved "free" output when project quotas are defined, but
	  haven't been enable on the filesystem.
	  Thanks to Utako Kusaka <utako@tnes.nec.co.jp> for the above four
	  fixes.

xfsprogs-2.9.2 (18 July 2007)
	- Next major round of xfs_repair performance improvements:
		- Cache disk nlink values in Phase 3 for Phase 7.
		- Do multithreaded prefetch/processing based on AG stride
		  option (ie. for concats).
		- Don't trash lost+found at the start of Phase 4, eliminates
		  repeated "moving disconnected inode to lost+found" with
		  successive xfs_repair runs.
		- Do multi-threaded sequential metadata prefetch.
		  Method based on Agami patches posted for 2.7.18 xfsprogs.
		- Improve the libxfs cache with priority tagging to keep
		  blocks around that have unfavourable I/O characteristics.
	- Make mkfs.xfs -f zero the old secondary superblocks before writing
	  the new superblocks.
	- Fix up xfs_info and xfs_quota's -c handling with global commands.
	- Improve xfs_bmap -vp output to always show the FLAGS column.
	- Update man pages.

xfsprogs-2.9.1 (28 June 2007)
	- Added filestreams support to xfs_io.
	- Fix up libattr Makefile to append to LTLDFLAGS. Thanks to
	  Arfrever Frehtes Taifersar Arahesis <Arfrever.FTA@GMail.Com> for this.
	- Fix up build not to ignore LDFLAGS generated by configure.
	  Thanks to SpanKY <vapier@gentoo.org> for this.

xfsprogs-2.9.0 (5 June 2007)
	- Added new tools: xfs_metadump and xfs_mdrestore.
	- Fix up the HAVE___U32 fix from 2.8.20
	  Thanks to Eric Sandeen for pointing this out.

xfsprogs-2.8.21 (28 May 2007)
	- Add support for lazy superblock counters in mkfs.xfs, xfs_db,
	  xfs_repair, xfs_growfs and also libxfs.
	- Fix xfs_quota project command to stop it operating on special files.
	  Thanks to Leo Baltus.

xfsprogs-2.8.20 (23 February 2007)
	- Fix xfs_repair not detecting invalid btree root in inodes.
	- Fix xfs_repair restoring corrupted superblock after repairing it.
	- Fix xfs_repair crashing on invalid quota inode values.
	- Fix xfs_quota gracetime reporting.
	  Thanks to Utako Kusaka <utako@tnes.nec.co.jp> for this.
	- Fix libxfs IO_DEBUG output.
	- Instead of using AC_CHECK_TYPES which isn't supported for
	  older versions of autoconf, add our own type check in the
	  m4/package_types.m4 file for __u32.
	  Suggested by Nathan Scott and discovered by wookey@aleph1.co.uk.

xfsprogs-2.8.19 (31 January 2007)
	- Fix pthread stack size setting in xfs_repair.
	- Fix xfs_bmap -n option displaying a truncated extent.
	- Fix xfs_io mwrite segfault. Thanks to Utako Kusaka for these two
	  fixes.
	- Fix errors in xfs_quota(8) man page.

xfsprogs-2.8.18 (8 December 2006)
 	- <xfs/list.h> is an installed file, we cannot simply rename it,
 	  as other applications using it (accidentally or not) may break.
 	  The xfs_list.h name was inconsistent with everything else too.
 	- Fix "pointer targets in assignment differ in signedness" warnings
 	- Update Debian packaging.
	- Fix up two issues with xfs_db and bmap. If the data/attr fork is
	  local, it either infinite loops or crashes. If both are displayed,
	  the attrs are wrong.
	- Fix up xfs_io mmap read that read from the wrong offset.
	- Updated xfs_io man page.
	  Thanks to Utako Kusaka <utako@tnes.nec.co.jp> for the above three
	  fixes.

xfsprogs-2.8.17 (5 December 2006)
	- Fix up libxfs SEGV when attempting to mount a non-XFS filesystem.
	  Thanks to Utako Kusaka <utako@tnes.nec.co.jp> for this.
	- Fix up xfs_repair aborting if it finds an inode with an invalid
	  inode type.
	- Fix up default realtime extent size for large block sizes.
	- Rename include/list.h to xfs_list.h so that other applications
	  do not accidentally use it.

xfsprogs-2.8.16 (30 October 2006)
	- Fix up an endian problem for nlink setting in phase 7 for xfs_repair.

xfsprogs-2.8.15 (19 October 2006)
	- Fix up nlink checks and repairs in phase 7 for xfs_repair.
	- Remove a bogus LEAFN warning for a single leaf node v2 dir.
	  Thanks to Roger Willcocks <roger@filmlight.ltd.uk> for this.

xfsprogs-2.8.14 (6 October 2006)
	- Fix up the ring command in xfs_db,
	  Thanks to Utako Kusaka <utako@tnes.nec.co.jp> for this.
	- Set the blocksize on the device to the given sector
	  size which is _not_ necessarily 512 bytes;
	  idea suggested by Shailendra Tripathi.
	- Fix up xfs_copy and its variable argument handling
	  around vfprintf; xfs_copy was seg faulting on x86_64.

xfsprogs-2.8.13 (21 September 2006)
	- Fix v2 directory checking with holes and unreadable blocks.
	- Fix a memory leak in dir2 checking.
	- Update libdisk/md support to work out the stripe width
	  based on (# raid-disks - # parity disks) which
	  doesn't include any spare disks (which we mistakenly did before).
	  Thanks to Shailendra Tripathi's suggestions.
	- Get the kernel int types of __u32 and friends from <asm/types.h>
	  if we can, otherwise define them ourselves.

xfsprogs-2.8.12 (29 August 2006)
	- Multi-thread modifications to xfs_repair.
	- Updated Polish translation, thanks to Jakub Bogusz.
	- Change default mkfs realtime extent size setting to
	  perform better for buffered writes.

xfsprogs-2.8.11 (08 August 2006)
	- xfs_repair prefetch optimisations.
	- Make many tools use direct I/O on Linux if the underlying
	  device supports it.  Mainly for speeding up xfs_repair as
	  libxfs does its own internal metadata buffering now.
	- Fix warnings from mkfs.xfs on ramdisk devices.
	- Fix issues with symbolic link handling in Makefiles.

xfsprogs-2.8.10 (02 August 2006)
	- Fix v2 directory rebuilds in phase6 of xfs_repair.
	- Fix buffer sizing issue for large pagesize systems,
	  affecting mkfs auto-device-type-detection heuristics.

xfsprogs-2.8.9 (18 July 2006)
	- Fix rpm issue with install targets as uid/gid zero (we now
	  using symbolic names rather than the numeric versions).

xfsprogs-2.8.8 (14 July 2006)
	- Fix issues with makedepend on libtool libraries.

xfsprogs-2.8.7 (10 July 2006)
	- Fix build of xfs_logprint for different uuid_t definitions;
	  thanks to Craig Rodrigues.

xfsprogs-2.8.6 (07 July 2006)
	- Fixed xfs_repair handling of duplicate names in a directory.

xfsprogs-2.8.5 (05 July 2006)
	- Update translation Makefile to work better with the Ubuntu
	  translation system.  Thanks to feedback from Martin Pitt.
	- Fix annoying "ignores datarootdir" warning from configure.
	- Fix issues with makedepend build infrastructure.
	- Add prefetch code for improved xfs_repair run times.

xfsprogs-2.8.4 (23 June 2006)
	- Improve Debian udeb package handling, thanks to Frans Pop.
	- Fix a situation where xfs_growfs can fail to match a block
	  device to a filesystem correctly; thanks to Bastian Kleineidam.
	- Minor corrections to the xfs_growfs man page.

xfsprogs-2.8.3 (21 June 2006)
	- Fix a possible segv in xfs_growfs; thanks to Bastian Kleineidam.

xfsprogs-2.8.2 (17 June 2006)
	- More updates to repair/libxfs for improving performance
	- Incorporate librt into the build process for lio_listio
	- Minor xfs_logprint tweaks and fixes.
	- Small updates to xfs_io manual page.
	- Several fixes from earler 2.8 releases with respect to
	  inode/buffer cache refcounting.

xfsprogs-2.8.1 (29 May 2006)
	- Fix endianness issues on FreeBSD.

xfsprogs-2.8.0 (18 May 2006)
	- Initial pass at user space caching, ultimately provides
	  a starting point for a faster, parallel version of repair.
	- Fix several inode/buffer reference counting issues.
	- Fix compiler warnings, and builds on certain glibc versions
	  having issues with the device major() macro.
	- Added code to xfs_db and xfs_admin to allow conversion
	  from version 1 to version 2 logs.

xfsprogs-2.7.18 (16 May 2006)
	- Fixed a case where xfs_repair was reporting a valid used
	  block as a duplicate during phase 4.
	- Fixed a case where xfs_repair could incorrectly flag extent
	  b+tree nodes as corrupt.
	- Portability changes, get xfs_repair compiling on IRIX.
	- Parent pointer updates in xfs_io checker command.
	- Allow LDFLAGS to be overridden, for Gentoo punters.

xfsprogs-2.7.17 (05 April 2006)
	- Fix libxfs access(2) check on /proc/mounts, which was
	  causing issues when xfs_check/xfs_repair run on readonly
	  root filesystem mounts.
	- Fix Debian packaging for libc-dev build dependency.
	- Fix up auto lib64 install detection for x86_64 platforms.

xfsprogs-2.7.16 (22 March 2006)
	- Fix freespace accounting in xfs_quota(8) df command.
	- Fix a typo on the xfs_quota(8) man page.
	- Make -O2 (cc optimisation level) the default.

xfsprogs-2.7.15 (03 March 2006)
	- Fix the way external log/realtime devices were handled in
	  userspace with older kernels (subtely different in procfs)
	- Fix a corruption problem in xfs_copy(8) when attempting to
	  zero the (old) log, a section was sometimes missed (depends
	  on log and I/O buffer (mis)alignment).

xfsprogs-2.7.14 (15 February 2006)
	- Debian packaging updates (debmake out, debhelper in).
	- Fix a header to work with additional compiler variants.

xfsprogs-2.7.13 (08 February 2006)
	- Convert fsck into a shell script and make it provide a
	  hint to run repair/check (in non-auto fsck modes).
	  Thanks to Marian Jancar <mjancar@suse.cz> for this.
	- Fix compilation botch on non-Linux platforms (duplicate
	  type definitions).

xfsprogs-2.7.12 (31 January 2006)
	- Added initial Polish translation.
	  Thanks to Jakub Bogusz <qboosh@pld-linux.org> for this.
	- Fixed rpm specfile with respect to INSTALL_{USER,GROUP}.

xfsprogs-2.7.11 (16 January 2006)
	- Fix a problem with the generated source tarballs and a
	  missing parent.h header file.

xfsprogs-2.7.10 (16 December 2005)
	- Make xfs_db keep trying when root inode can't be read.
	- Make xfs_db check AGF BNO and CNT btree consistency.
	- Tweak a couple of libxfs headers so they can be used by
	  C++ programs (removes nested struct declarations, which
	  are used outside the scope they're declared in).
	- Fix a rounding issue in xfs_quota time reporting, making
	  it more consistent with the standard quota utilities.
	- Fix dopey libxfs message "Unmount and run xfs_repair.",
	  especially annoying when printed by xfs_repair itself.
	- Fix a dir2 xfs_repair bug, misdiagnosing a valid dir as
	  corrupt.  Thanks to Masanori Tsuda.

xfsprogs-2.7.9 (08 December 2005)
	- Fix thinko in libxcmd cvtnum routine
	- Fix EFI/EFD printing in xfs_logprint

xfsprogs-2.7.8 (05 December 2005)
	- Extend xfs_io to do aligned direct IO automatically
	- Report direct IO parameters (dioinfo) in xfs_io
	- Make xfs_mkfile a shell script wrapper around xfs_io

xfsprogs-2.7.7 (16 November 2005)
	- Fix some gcc compiler warnings on 64 bit platforms.
	- Remove last reference to a <linux/*.h> (kernel) header.
	- Updated aclocal.m4
	- Fix a bug in xfs_io lsproj/chproj recursive modes.
	- Add xfs_io recursive modes for the extsize command.
	- Add xfs_db version command modes for attr1 and attr2.

xfsprogs-2.7.6 (31 October 2005)
	- Add support for the inode extent size hint for the regular
	  data device (previously was realtime only), and allow the
	  optional inheritance of this property.
	- Add support for additional read/write patterns in xfs_io
	  (reverse and random, in addition to sequential forwards).
	- Add some mkfs debugging options to aid testing inheritance
	  of realtime, project ID, and extsize inode attributes.
	- Add mkfs option for forcing use of ATTR2, and make growfs
	  report its use.
	- Fix use of cursor in attr_list_by_handle() libhandle code.
	- Fix several compiler warnings when building on IRIX.

xfsprogs-2.7.5 (26 October 2005)
	- Fix an endian bug in xfs_db "frag" command.
	- Fix some errors on the xfs_quota(8) man page.

xfsprogs-2.7.4 (08 October 2005)
	- Fix read and write calls in xfs_io to allow buffers larger
	  than 4GiB on 64 bit platforms.
	- FreeBSD build tweaks from Craig Rodrigues.
	- Fixed a few minor compiler warnings.

xfsprogs-2.7.3 (29 September 2005)
	- Fix xfs_repair handling of the morebits bit.
	- Merge back several kernel changes related to attr2.
	- Extended xfs_db expert mode commands
	- Clean up some fsxattr uses to reduce number of syscalls,
	  now that IRIX also supports project identifiers via this
	  interface.

xfsprogs-2.7.2 (28 September 2005)
	- Fix up xfs_repair segmentation fault due to wrong allocation
	  size.

xfsprogs-2.7.1 (20 September 2005)
	- Fix up reporting of devices in xfs_growfs - now uses
	  /proc/mounts in preference to /etc/mtab.
	- Fix a strtok-related bug in the extraction of device names,
	  also only affecting xfs_growfs.

xfsprogs-2.7.0 (16 September 2005)
	- Support for updated extended attributes format (attr2)
	- Make xfs_quota tool issue a quota sync in all the needed
	  places, before reporting, to counter affects of delayed
	  allocation.
	- Quota-related ID signedness issue fixes.
	- Expert mode xfs_db commands to set/remove attributes.

xfsprogs-2.6.37 (11 August 2005)
	- Fix FreeBSD builds (getmntinfo), thanks to Craig Rodrigues.

xfsprogs-2.6.36 (28 July 2005)
	- Fix mkfs stripe unit alignment checks for external logs
	- Fix running xfs_db on non-XFS devices (was segfaulting)
	- Fix a 32 bit wrap in xfs_repair searching for secondary
	  superblocks.

xfsprogs-2.6.35 (01 July 2005)
	- Add back fd_to_handle() to libhandle.
	- Add handle call mappings to xfsctl() for IRIX.

xfsprogs-2.6.34 (20 June 2005)
	- Switch to the fsxattr xfsctl for getting/setting project
	  identifiers on inodes, remove the short-lived specialised
	  ioctls for doing this.
	- Make the "blocktrash" xfs_db command available in expert-
	  mode only.

xfsprogs-2.6.33 (13 June 2005)
	- Another libhandle fix on 64bit, Big Endian systems.

xfsprogs-2.6.32 (08 June 2005)
	- Minor endian cleanups in some tools.
	- Fix a couple of xfs_quota double-reporting issues when
	  issuing commands via the -c (command line) 0option.

xfsprogs-2.6.31 (06 June 2005)
	- Fix previous MD driver-specific change to correctly handle
	  (i.e. not "stripe align") linear arrays.
	- Add MD RAID level 4, 6, and 10 support.
	- Make mkfs.xfs automatically adjiust the geometry to use
	  a sector size that matches the block size when MD RAID
	  level 4/5/6 are in use.
	- Couple of minor man page fixups, including patch botch on
	  initial revision of xfs_quota(8).

xfsprogs-2.6.30 (03 June 2005)
	- Add xfs_quota(8) command which knows how to do all things
	  quota related, and can also do the XFS specific extensions
	  like project quota, realtime device quota, etc.
	- Created a library of common code (libxcmd.a) shared by
	  xfs_growfs, xfs_io and xfs_quota.
	- Fix use of regular files for realtime subvolumes (debugging
	  only, really).
	- Fix bug in xfs_io command line option handling when commands
	  where specified for multiple files at once.
	- Allow xfs_io to specify O_NONBLOCK for regular file IO.
	- Fix MD driver-specific code to not attempt stripe alignment
	  for volumes that are not stripes (e.g. concat/mirror).

xfsprogs-2.6.29 (19 April 2005)
	- Fix mkfs.xfs -dfile.
	- Fix libhandle on 64bit, Big Endian systems.

xfsprogs-2.6.28 (30 March 2005)
	- Fix compiler warning in repair/dir.c size checks.
	- Fix more compilation problem with version 4 of gcc
	  (thanks to Andreas Jochens).
	- Make xfs_db and xfs_repair cope with filesystems that
	  have project quota enabled.

xfsprogs-2.6.27 (23 March 2005)
	- Fix default mkfs allocation group size calculations
	  for filesystem sizes in the range 32 - 64 terabytes.
	- Add noalign mkfs suboptions for -d/-r to disable the
	  sunit/swidth auto-alignment (based on logical volume
	  geometry, extracted from the driver).

xfsprogs-2.6.26 (08 March 2005)
	- Fix compilation problem with version 4 of gcc
	  (thanks to Andreas Jochens).
	- Added a streamlined <xfs/xfs.h> for programs wanting
	  to make use of the XFS-specific kernel interfaces (to
	  address complaints that <xfs/libxfs.h> was "heavy").
	- Add imap as an expert command in xfs_io, making it
	  more easily accessible to those who need it.
	- Extended statistics reporting for xfs_io command.
	- Fixed readline support for current distributions.
	- Add an --enable-termcap=[yes/no] configure option,
	  and changed --enable-readline=[yes/no] to not force
	  linking with libtermcap.  Builds on some platforms
	  may need to use both options, but most distributions
	  do not require --enable-termcap when linking against
	  libreadline.
	- Minor man page updates.

xfsprogs-2.6.25 (08 October 2004)
	- Fix build with really old glibc versions.

xfsprogs-2.6.24 (29 September 2004)
	- Allow 'e' suffix in size arguments to mkfs.
	- Update mkfs man page description of maximum allocation
	  group size.
	- Update mkfs and xfs_db man pages to use consistent,
	  standard notations.
	- Sync up user/kernel source in libxfs and headers.

xfsprogs-2.6.23 (17 September 2004)
	- Fix xfs_io pread/pwrite -b option, when used more than
	  once we would use the largest of the previous values,
	  instead of the (possibly smaller) value specified.
	- Add recursive modes to lsattr/chattr xfs_io commands.
	- Make xfs_io run any given command line commands (-c)
	  on all files specified, not just the first.

xfsprogs-2.6.22 (10 September 2004)
	- Update xfs_io to get a clean compile on IRIX with the
	  MIPSPro compilers.
	- Add documentation about additional XFS inode flags.
	- Add xfs_io write options to include fsync/fdatasync
	  in the timing results it displays.
	- Add xfs_fsop_counts output to the xfs_io statfs data,
	  which also shows free realtime space, etc.
	- Add knowledge of additional inode flags for nosymlinks
	  and project ID inheritance.

xfsprogs-2.6.21 (09 August 2004)
	- Support realtime bit inheritance on directories.
	- Fix xfs_io build with unusual (old) glibc versions.
	- Fix tools to not issue the BLKFLSBUF ioctl to ramdisk
	  devices.  Thanks to Bo Yang for this fix.

xfsprogs-2.6.20 (28 July 2004)
	- Fix a segfault on xfs_io open error path for non-XFS
	  files.  Thanks to Steinar H. Gunderson for this fix.

xfsprogs-2.6.19 (16 July 2004)
	- Fix two byte count size wraps in xfs_copy.
	- Minor man page fixes from Eric Raymond.

xfsprogs-2.6.18 (23 June 2004)
	- Fix libhandle from possibly returning an invalid
	  handle length on systems where size_t is 64 bits.
	- Minor autoconf fixups to get rpm test working on
	  all platforms again.
	- Minor man page updates fixing minus/hyphen usage.

xfsprogs-2.6.17 (23 June 2004)
	- Fix use of isset macro, getting realtime devices to
	  function correctly in xfs_db and xfs_repair.
	- Fix initialisation of realtime devices in libxfs.

xfsprogs-2.6.16 (17 June 2004)
	- Add sendfile command into xfs_io(8) to exercise that
	  functionality.
	- Remove maxtrres program that was used in the build
	  to generate a header for mkfs' consumption.
	- This allows cross-compiles to be greatly simplified.
	- Portability tweaks for building on other platforms.
	- Fix obscure bug in log size lower boundary checks for
	  auto-sized logs when stripe alignment is in effect;
	  the enforced lower bound could have been set too low.

xfsprogs-2.6.15 (09 June 2004)
	- Make xfs_check test for a dirty log before proceeding to
	  check the filesystem.
	- Fix couple of minor bugs in xfs_io (readonly handling on
	  writes, off-by-one error in open file error reporting).

xfsprogs-2.6.14 (13 May 2004)
	- Allow logprint to copy a log to a file (-C) and to dump
	  a log from beginning to end showing ondisk log record (-d).
	- Fix logprint handling of -f option - shouldn't be doing
	  the UUID check in that case, since we don't have the SB.
	- Remove MD device superblock "clean" check, following Neil
	  Brown's advice.
	- Small Debian packaging tweak to say xfsprogs has an fsck.

xfsprogs-2.6.13 (03 May 2004)
	- Zero out more at beginning and end of device at mkfs time
	  (get all old MD superblocks at the end, for mount by label).

xfsprogs-2.6.12 (30 April 2004)
	- Extract stripe unit/width from device mapper devices
	  (added libdisk infrastructure, used by mkfs.xfs).
	- Fix rounding in xfs_io(8) bytes read/written output.
	- Sync up user/kernel source in libxfs and headers.
	- Fix compiler warnings on 64 bit platforms.
	- Update i18n message catalog.

xfsprogs-2.6.11 (15 April 2004)
	- Fix file descriptor leak in path_to_fshandle. A file
	  was being opened but never closed, regardless of
	  whether that descriptor was being cached. Now close
	  the file on error or if it is not being cached.
	- Fix xfs_repair handling of a corrupt v2 directory with
	  multiple entries having the same name.

xfsprogs-2.6.10 (05 April 2004)
	- Fix botch in recent addition of new superblock field
	  (features2) which could result in filesystems with v2
	  logs being created with invalid superblock fields.
	  Thanks to Chris Pascoe for this fix.
	- Fix error when forcing a too-large v2 log stripe size
	  back to 32K.  Thanks to Chris Pascoe for this fix too.
	- Fix xfs_copy -d option so that it really does create a
	  duplicate filesystem (the log is duplicated too now in
	  that case, whereas previously a fresh log was created).

xfsprogs-2.6.9 (26 March 2004)
	- Update HFILES in xfsprogs/io/Makefile to package io/io.h

xfsprogs-2.6.8 (25 March 2004)
	- Fix xfs_db when dumping v2 dirs larger than the fsb size.
	- Several xfs_io additions - support for memory mapped areas,
	  multiple open files, expert mode (freeze, shutdown, error
	  injection, etc), fadvise (Linux-specific), allow user to
	  specify a create mode to open(2).
	- Fix xfs_bmap verbose mode stripe alignment information.
	- Fix typo on xfs(5) man page.

xfsprogs-2.6.7 (19 March 2004)
	- Fix up UUID library checks again, previous fix didn't work
	  for older versions of autconf.
	- Allow for future extensions to the XFS ondisk structure by
	  reserving an extra 32 bits in the superblock for feature
	  bits (update xfs_db to dump them).
	- Fix xfs_repair handling of version 2 directories with a
	  hole at the start.
	- Fix an endian bug in xfs_copy, when operating on allocation
	  groups with multi-level freespace btrees.
	- Ensure xfs_repair "dangerous" mode does not attempt to set
	  the device blocksize, this generates an error when target
	  filesystem is mounted readonly.

xfsprogs-2.6.6 (03 March 2004)
	- mkfs now opens the devices it's operating on with the
	  O_EXCL flag set, which is used by the Linux 2.6 block
	  layer to ensure concurrent access does not happen.
	- Allow xfs_io to operate on files from other filesystems,
	  with the XFS-specific commands unavailable in this mode.
	- Fix configure scripts to also search for a UUID library
	  in /usr/lib64 which is its home on AMD64/x86_64.

xfsprogs-2.6.5 (20 February 2004)
	- Fix up mkfs to ensure that the log size is a multiple of
	  the v2 log stripe size even if the log happens to be aligned
	  on a log stripe boundary (always check it).

xfsprogs-2.6.4 (17 February 2004)
	- Fix a few more libxfs/repair leaks.
	- Fix up some libhandle routines, add the open_by_fshandle
	  routine required by recent versions of xfsdump.

xfsprogs-2.6.3 (19 January 2004)
	- Merge Steve Langasek's work on the Debian installer
	  support for xfsprogs.
	- Add knowledge to xfs_db about the security namespace in
	  its extended attributes commands.
	- Sync up user/kernel source in libxfs and headers.
	- Fix a couple of compilation warnings.
	- Workaround for some versions of autoconf mishandling the
	  AC_CHECK_SIZEOF macro.
	- Fix a memory leak in libxfs, most noticable in xfs_repair.

xfsprogs-2.6.2 (17 December 2003)
	- Fix dev_t sizing issues in user tools - glibc uses a 64
	  bit number and XFS has a 32 device bit number, confusion
	  reigns.  Not much manipulates device numbers in the XFS
	  user tools though, hence hasn't really been seen before.
	  Thanks to Christoph for the patch.

xfsprogs-2.6.1 (27 November 2003)
	- Human-friendly xfs_io read/write bsize specifications.
	- Dump throughput and IOPs values after xfs_io reads/writes.
	- Sync up user/kernel source in libxfs, libxlog and headers.

xfsprogs-2.6.0 (28 October 2003)
	- Change to mkfs strategy for allocation group count and size
	  default.  Scales significantly better for large filesystems.

xfsprogs-2.5.11 (10 October 2003)
	- Incorporate Jan Derfinaks change to the Linux block ioctls
	  used in libxfs, allowing this code to compile cleanly with
	  include files from Linux 2.6.0-test5 onward.

xfsprogs-2.5.10 (30 September 2003)
	- Fix up xfs_logprint to handle version 2 logs for its
	  operation output (previously core dumped on it).

xfsprogs-2.5.9 (19 September 2003)
	- Sync up user/kernel source in libxfs, libxlog and headers.
	- Add new inode flags into xfs_db too.

xfsprogs-2.5.8 (12 September 2003)
	- Add missing options to xfs_db frag command one-line summary.
	- Add xfs_io commands for setting and clearing new inode flags
	  for immutable/append-only/sync/no-atime/no-dump.
	- Dump some other statfs fields in the xfs_io statfs commands.
	- Remove "test" mode from xfs_repair, only useful in xfs_check.
	- Fix problem in xfs_logprint where it was trying to continue
	  in the presence of a corrupt log when it shouldn't have.
	- Fix an incorrect assertion in xfs_logprint in regards to the
	  validity of the log start block.
	- Fix xfs_growfs (and hence xfs_info) to allow it to be given
	  either a mount point or a device in the mount table - it'll
	  figure it out and should do the right thing either way now.

xfsprogs-2.5.7 (29 August 2003)
	- Sync up user/kernel source in libxfs and headers.
	- Make xfs_copy a tad more portable, although work remains.
	- Add a "test" mode to xfs_repair and xfs_check which allows
	  for sparse (and hence extremely large) filesystem testing.

xfsprogs-2.5.6 (19 August 2003)
	- Fix a mkfs problem where it could exit inappropriately when
	  a large data volume stripe unit was either specified on the
	  command line or via querying the underlying volume manager.

xfsprogs-2.5.5 (07 August 2003)
	- Update xfs_io command to allow reading from non-XFS files.
	- Sync up user/kernel source in libxfs, libxlog and headers.
	- Update xfs_db and xfs_logprint commands to print new inode
	  flush iteration field.

xfsprogs-2.5.4 (23 July 2003)
	- Update xfs_io bmap command to report unwritten extent flag
	  if it is set on an extent (in verbose mode only).
	- Introducing xfs_copy.
	- Fix shell quoting problem in xfs_bmap script.

xfsprogs-2.5.3 (07 July 2003)
	- Update xfs_io commands which take user input in terms of
	  byte counts to now also allow unit prefixes like mkfs.xfs.
	- Tweak build to avoid unnecessary rebuilds of international
	  language files (if present), suggested by Steve Langasek.
	- Fix usage message in mkfs.xfs, it was out of date.
	- Fix some filesystem type detection code, in particular the
	  bfs probe code was broken for 64 bit machines (found by QA
	  test 032) and the hfs code was broken too (originally found
	  by Ethan Benson).  We now also detect hfs+ filesystems.

xfsprogs-2.5.2 (25 June 2003)
	- Fix xvm stripe detection in libdisk - pass correctly
	  sized structures to xvm ioctls.
	- Add pthread library checks into configure and build scripts
	  for work-in-progress on xfs_repair and xfs_copy.
	- Fix missing initialisation of stripe unit/width alignment
	  information during libxfs_mount.
	- Fix botched repair typecast for multi-terabyte filesystems.

xfsprogs-2.5.1 (23 June 2003)
	- Fix libdisk device driver (volume managers) detection code
	  used by mkfs, so that drivers with multiple majors are not
	  incorrectly processed.

xfsprogs-2.5.0 (18 June 2003)
	- Fix libdisk (and hence mkfs) code which warns on MD devices
	  with the clean flag not set, apparently this is not so wise.
	- Fix libxfs_device_zero to work with smaller-than-requested
	  write return values.
	- Fix error in xfs_io pwrite code with large request sizes.
	- Fix rounding-down-input problems in several xfs_io commands.
	- Changed mkfs.xfs default log size scaling algorithm slightly,
	  to create larger logs at smaller filesystem sizes by default
	  (thanks to Andi Kleen for the patch).
	- Enable support for sector sizes larger than 512 bytes.

xfsprogs-2.4.12 (02 June 2003)
	- Fix xfs_logprint handling of any version 2 log device.
	- Remove calls to exit in libhandle, propogate errors to
	  caller, and bumped libhandle version from 1.0.1 to 1.0.2.

xfsprogs-2.4.11 (30 May 2003)
	- Extract device sector size at mkfs time and issue warnings
	  if the requested filesystem sector size is too small.
	- Sync up user/kernel source in libxfs, libxlog and headers.
	- Skip realtime initialisation in libxfs mount path if the
	  caller is xfs_db, otherwise we get nonsense warnings.
	- Update xfs_io with a couple of additional commands.
	- Fix xfs_logprint handling of corrupt v2 log devices.

xfsprogs-2.4.10 (12 May 2003)
	- Fix a bug in mkfs - creating version 2 logs, an incorrect
	  stripe unit value was being passed to libxfs_clear_log.
	  All recent versions of xfs_repair will fix this, however,
	  because xfs_repair uses the correct stripe unit value.
	- Fix a bug in xfs_logprint, when dumping a corrupt log.
	- FreeBSD updates from Alexander Kabaev.
	- Large sector size updates for mkfs (disabled at the moment).
	- Large sector size fixes for xfs_repair.
	- Sync up with aeb's mount source for filesystem detection.

xfsprogs-2.4.9 (03 May 2003)
	- Allow xfs_repair to run on read-only filesystems.

xfsprogs-2.4.8 (26 April 2003)
	- Rework configure.in to make use of shared macros.
	- Fix up #include lines to allow compilation of sources
	  with installed headers rather than local headers.
	- Fix botches in xfs_bmap shell script which prevented any
	  arguments being passed on to xfs_io (from Jan Derfinak).

xfsprogs-2.4.7 (22 April 2003)
	- Clarify XFS system call interfaces, fix up documentation.

xfsprogs-2.4.6 (11 April 2003)
	- Fix a bug in detection of "clean" and "error" states with
	  MD devices.
	- Fix configure tests that used AC_PATH_PROG incorrectly.
	- Add support for libedit, if libreadline is unavailable.
	- Fix the libxfs build on big endian platforms.
	- Sync up user/kernel source in libxfs and headers.

xfsprogs-2.4.5 (03 April 2003)
	- Sync up xfs_inode.c in libxfs.
	- Implement get_unaligned/put_unaligned in libxfs.

xfsprogs-2.4.4 (30 March 2003)
	- Correct display of imaxpct in mkfs.xfs output.
	- Portability changes; including some code to support use
	  of several tools on Mac OS X (for Russell), ditto for
	  FreeBSD (from Russell); also did a simplistic backport
	  to IRIX (for me), so that I can run purify on some of
	  the tools.
	- See doc/INSTALL for more details on this.
	- Sync up user/kernel source in libxfs and headers.
	- Fix up some warnings when compiling libxfs on big endian
	  platforms.
	- Fix a configure.in botch which resulted in libreadline
	  always being used even when it was not asked for.
	- Fixed the configure.in script so that if gettext disabled,
	  we don't check for the gettext tools (and no longer fails
	  if they were not found).
	- Added the ability to specify a different user and/or group
	  to install as (previously, and still by default, root/root
	  were always used here).

xfsprogs-2.4.3 (27 March 2003)
	- Cleanups to the build process, in particular the automatic
	  rpm package generation Makefile and spec file template.
	- Makepkgs script can now propagate failures back from make.
	- Minor configure.in update to deal with readline libraries
	  which have not been linked correctly.

xfsprogs-2.4.2 (25 March 2003)
	- Added the xfs_io(8) command, an xfs_db(8) alike command
	  for testing and debugging the XFS file IO path.
	- Added an optional dependency on the GNU readline library
	  which is "off" by default and enabled with the configure
	  option --enable-readline=yes; it affects the interactive
	  tools only (xfs_db and now xfs_io).
	- Implemented xfs_bmap(8) as a shell script wrapper.
	- Documented the mkfs.xfs -f, -llogdev and -rrtdev options.
	- Corrected size check for realtime summary inode (not the
	  same as the realtime bitmap inode) in xfs_repair.

xfsprogs-2.4.1 (18 March 2003)
	- Fix error reporting when zeroing parts of the realtime
	  device in phase6 of xfs_repair.
	- Add a mkfs.xfs check for Mac partitions before writing
	  to the device.
	- Thanks to Ethan Benson <erbenson@alaska.net> for this.
	- Minor fix to the xfs_bmap(8) man page.
	- Sync up user/kernel source in libxfs and headers.

xfsprogs-2.4.0 (06 March 2003)
	- Enable unwritten extents by default in mkfs.xfs.
	- Add a command to xfs_db to enable unwritten extents.
	- Add an option to xfs_admin to use the above command.
	- Add command to xfs_db to print out the currently enabled
	  feature bits and version number.
	- Make xfs_db slightly more robust in the presense of bad
	  ondisk data.
	- Rationalise some xfs_db superblock-related code and the
	  uuid command now checks for a dirty log before zeroing.
	- Add stripe alignment information to xfs_bmap.
	- Sync up user/kernel source in libxfs and headers.
	- Update man pages, fix a typo in the xfs_admin man page
	  relating to the UUID options.

xfsprogs-2.3.11 (18 February 2003)
	- Missed a build dependency for the Debian build process.

xfsprogs-2.3.10 (17 February 2003)
	- Fix a divide-by-zero error in mkfs with certain stripe unit
	  and/or width options specified.
	- Sync up user/kernel source in libxfs and headers.

xfsprogs-2.3.9 (31 December 2002)
	- Additional xfs_repair check in v2 directory handling for blks
	  with no data entries (merged from IRIX), includes several
	  handy comments sprinkled throughout this v2 dir code.
	- Fix an endian bug in the same area of code (v2 dirs, phase 6,
	  longform_dir2_rebuild_setup)
	- xfs_repair has additional checks for bad sector values now.
	- xfs_repair I18N changes.
	- Fix detection of readonly mounts, slightly botched in 2.3.8.
	- Fix references to removed ioctl commands on xfs(5) man page.

xfsprogs-2.3.8 (18 December 2002)
	- Initial support for I18N (still more to do here).
	- Initial changes for filesystems with greater than 512 byte
	  sector sizes (still plenty more to do here too).
	- Tidy up libxfs functions which take a "flags" argument.
	- Sync up user/kernel source in lib{xfs,xlog} and headers.
	- Fixed incorrect use of XFS_FSB_TO_DADDR macro in xfs_db's
	  faddr.c::fa_dirblock routine - now use XFS_FSB_TO_BB here,
	  as set_cur() takes basic blocks as its third parameter.
	- Fixed obscure issue in mkfs where only the first AG would
	  get its AGFL freelist "fixed" - not clear this caused any
	  issues in practice (on Linux it's always been this way, we
	  now match up with IRIX though).
	- Made xfs_growfs filesystem geometry output match up with
	  that displayed by mkfs.xfs (xfs_growfs was missing a comma
	  before the log version field).
	- Fixed an issue in xfs_repair where data past the end of the
	  valid superblock fields was sometimes not cleared, when it
	  really should have been (due to a libxfs problem).
	- Shell scripts (xfs_info, xfs_check, etc) now also report
	  the xfsprogs version number via -V, like other commands.

xfsprogs-2.3.7 (14 November 2002)
	- Fix an endian bug in xfs_db freesp command when descending
	  into multi-level agf cnt/bno btrees.

xfsprogs-2.3.6 (31 October 2002)
	- Sync up user/kernel source in lib{xfs,xlog} and headers.
	- Fix several warnings from newer (3.2) versions of gcc.
	- Minor header file shuffling.

xfsprogs-2.3.5 (10 October 2002)
	- Sync up user/kernel source in lib{xfs,xlog} and headers.
	- Fix mkfs (libxfs) bug when using BLKFLSBUF ioctl - we passed
	  in the device number instead of a file descriptor (and EBADF
	  was the end result, which we ignored).
	- Thanks to Anton Blanchard <anton@samba.org> for fixing this.

xfsprogs-2.3.4 (04 October 2002)
	- Fix size calculation bug in xfs_repair's memory allocation,
	  reduces memory usage by a factor of 4.

xfsprogs-2.3.3 (16 September 2002)
	- Fix mkfs bug when optimizing AG size on striped devices,
	  ASSERT(agcount != 0) tripped on single-ag filesystems.

xfsprogs-2.3.2 (10 September 2002)
	- Use pread/pwrite instead of lseek + read/write.

xfsprogs-2.3.1 (03 September 2002)
	- Allow xfs_db to accept negative numbers when writing values.

xfsprogs-2.3.0 (03 September 2002)
	- Several changes to geometry ioctl callers which will make
	  the tools useable on older kernel versions too.
	- Mainly affects xfs_bmap and xfs_growfs.
	- Do some additional cleanup after autoconf has run.

xfsprogs-2.2.3 (28 August 2002)
	- Update libdisk for a few other filesystems.
	- Fix call to lvdisplay on LVM volumes so that lvdisplay
	  always gets the full, real path to the volume, as required.

xfsprogs-2.2.2 (19 August 2002)
	- Fix endian bug in xfs_db, was not flipping 16-bit numbers.
	- Make xfs_repair recognize a NULLFSINO and print that in
	  addition to "18446744073709551615" for easy recognition.
	- Fix format string that xfs_repair uses when fixing inodes,
	  so that the new inode numbers are printed correctly.

xfsprogs-2.2.1 (09 August 2002)
	- Fix buglet in libdisk get_driver_block_major() routine which
	  would result in incorrect majors being returned for not-found
	  drivers.
	- Fix problem in install process with newer autoconf versions.

xfsprogs-2.2.0 (08 August 2002)
	- mkfs.xfs defaults to a blocksize of 4096 bytes, and no longer
	  uses getpagesize(2) to dynamically configure the default size.
	- Add EVMS stripe unit/width auto-detection support in mkfs.xfs
	  (patch from Luciano Chavez).
	- Sync user/kernel headers (arch.h incorporated into xfs_arch.h,
	  and several other minor changes).

xfsprogs-2.1.2 (17 July 2002)
	- Fix up log stripe unit specification options, and update
	  man page.  Also fix suffix handling for data su/sw options
	  (disallow unit suffixes on -d sunit,swidth,sw and -l sunit).
	  Add "s" (512-byte sectors) as valid suffix.
	- Automatically select v2 logs if a log stripe unit is
	  specified.

xfsprogs-2.1.1 (04 July 2002)
	- Build infrastructure updates so that configure options can be
	  used to specify paths rather than semi-hard-coded path names
	  controlled by the ROOT/ROOT_PREFIX environment variables; eg.
	  now allows /lib64 and /lib32

xfsprogs-2.1.0 (14 June 2002)
	- Support for XFS version 2 log format.
	- Fix for xfs_repair mangling i8count for dir2_sf directories
	- Minor mkfs.xfs man page update for blocksize limits on Linux
	- xfs_cred.h split into xfs_acl.h, xfs_cap.h and xfs_mac.h
	- Fix typo in mkfs realtime summary inode alloc failure message

xfsprogs-2.0.6 (30 May 2002)
	- Fix error returns from log recovery (affects xfs_repair).
	- Fix the way mkfs.xfs round downs the device when the last
	  AG is smaller than the minimum AG size.
	- Fix bug in xfs_repair da_write() routine, which affects
	  filesystems where the data blocksize != naming blocksize
	  (see xfs_info output).
	- Fix a use-after-free bug in xfs_repair code for checking
	  version 1 btree-format directories.
	- Add checks of the ACL permissions field into xfs_repair.

xfsprogs-2.0.5 (02 May 2002)
	- Size AGs so that they do not always start on the same
	  part of a striped disk
	- Fix an off-by-one error on rounding down an AG that is
	  too small to be an AG
	- Don't auto-grow the log to be larger than an AG
	- Change the error philosophy for -d su=,sw= away from forcing
	  the XFS stripe size to match the volume manager stripe size
	  and instead accept, with a warning, the stripe unit & width
	  supplied on the commandline.
	- Update xfs_growfs man page
	- Don't build libxlog.a with DEBUG enabled
	- xfs_db fixes from ASANO Masahiro at NEC

xfsprogs-2.0.4 (17 April 2002)
	- Minor update sync'ing with kernel changes (less endian
	  swabbing in libxfs code)

xfsprogs-2.0.3 (13 April 2002)
	- Important build system update, was causing libxfs to be
	  built incorrectly, which can cause xfs_repair to fail by
	  tripping asserts in additional libxfs debug code.

xfsprogs-2.0.2 (04 April 2002)
	- Bumped version of libhandle to libhandle.so.1.0.1
	  This changes open_by_handle() and friends so that
	  O_LARGEFILE is added to the open flags.
	  This allows xfsdump to dump files greater than
	  2^31-1 bytes instead of not dumping the large
	  files and giving warning messages.

xfsprogs-2.0.1 (12 March 2002)
	- Fall back to BLKGETSIZE if BLKGETSIZE64 fails
	- Sync user/kernel headers and shared code

xfsprogs-2.0.0 (26 February 2002)
	- Major release to coincide with switch to new extended
	  attributes system call interfaces
	- bumped version of libhandle, added new symbols to use
	  the reworked extended attributes handle ioctl interface
	- xfs_repair in no-modify mode opens the filesystem device
	  read-only now (fix from Chris Pascoe)
	- sync up with recent (minor) changes to shared kernel code
	- switch to using the BLKGETSIZE64 ioctl in libxfs, instead
	  of the (previously busted) BLKGETSIZE ioctl

xfsprogs-1.3.19 (15 February 2002)
	- fix xfs_repair option parsing for external logs
	- add xfs_repair option parsing for realtime device
	- fix xfs_repair version (-V) option - should not
	  require an argument
	- add -V option to usage string
	- document verbose (-v) and -r options in manpage

xfsprogs-1.3.18 (17 January 2002)
	- fix mkfs.xfs buglet in overwriting signatures when run
	  on a regular file

xfsprogs-1.3.17 (14 January 2002)
	- mkfs.xfs overwrites pre-existing filesystem, swap, or md
	  driver signatures.
	- xfs_repair fix to prevent double insertion into the
	  uncertain_inode AVL trees ("avl_insert: duplicate range")
	- xfs_repair fix if the log is corrupted and we can't find
	  the head, don't exit - just proceed on with zeroing it
	- use snprintf instead of sprintf throughout

xfsprogs-1.3.16 (17 December 2001)
	- added text dump type to xfs_db (mkp)
	- removed use of a temporary file in xfs_db when processing
	  commands on the command line - allows xfs_check to be run
	  on read-only root filesystems

xfsprogs-1.3.15 (12 December 2001)
	- reenable the use of the BLKBSZSET ioctl, it's baaack
	- sync recent XFS kernel source changes back into libxfs

xfsprogs-1.3.14 (05 December 2001)
	- fix minor debian package version numbering issue
	- add documentation for xfs_db(8) label/uuid commands
	- automatic inode sizing code in mkfs.xfs has been removed
	  (restricting inodes to 32 bits) - Steve's recent kernel
	  changes mean this is no longer an issue
	- fix bug in mkfs.xfs size cross-check for realtime device

xfsprogs-1.3.13 (25 October 2001)
	- fix bug in mkfs for 1Tbyte + filesystems
	- sync with recent kernel changes - this does not affect
	  userspace (libxfs), all affected code is removed by cpp.

xfsprogs-1.3.12 (17 October 2001)
	- implement the -f (file) option to xfs_logprint
	- rework the xlog code into libxlog for code sharing
	- xfs_repair now detects a dirty log and, without -L, will
	  no longer blindly zero it (which prevents any recovery)

xfsprogs-1.3.11 (17 October 2001)
	- tidy up some (benign) compiler warnings from libxfs
	- fixed 64-bit pointer alignment issues in xfs_check
	- fixed 64-bit pointer alignment issues in xfs_repair
	- verified these on IA64, also reported to fix sparc issues

xfsprogs-1.3.10 (12 October 2001)
	- sync with XFS kernel header changes for EAs by-handle
	- ported xfs_imap command for dumping the inode map

xfsprogs-1.3.9 (03 October 2001)
	- fix xfs_repair bug in handling a corrupt root directory
	  inode with multiple "lost+found" entries
	- fix xfs_logprint bug in scanning for log head and tail
	- ensure xfs_bmap doesn't issue XFS ioctls to non-XFS files
	- numerous man page updates

xfsprogs-1.3.8 (19 September 2001)
	- rewrote the LVM support used by mkfs.xfs to call external
	  lvdisplay program to get volume geometry (mkp@mkp.net)
	- fix bug in LVM driver wrapper where it would not have been
	  used at all, ever (since 1.3.0), due to idiot programmer
	  error (*blush*) -- also thanks to mkp for the bug fix

xfsprogs-1.3.7 (10 September 2001)
	- enable preallocation in xfs_mkfile [missed during port?]
	- fix xfs_db core dump when reporting freespace
	- allow libuuid to be linked dynamically if desired (based
	  on a patch from Colin Walters <walters@verbum.org>, helps
	  the folk working on the Debian installer for XFS)
	- licensing change for "libhandle" (was GPL, now LGPL-2.1)
	  and some related header files

xfsprogs-1.3.6 (31 August 2001)
	- make mkfs.xfs aware of geometries that might cause
	  inode numbers to exceed 32 significant bits.
	- make xfs_growfs warn if new filesystem will have
	  inode numbers that exceed 32 significant bits.
	- fix logprint bug in reporting extended attributes
	  (thanks to Tang Lingbo <tanglb@sina.com> for fixing this)
	- fix mkfs.xfs core dump when attemping to run on devices
	  which are too small to hold a valid XFS filesystem

xfsprogs-1.3.5 (13 August 2001)
	- fix bug in xfs_db bit handling on big endian platforms
	- fix mkfs bug related to too-small final allocation group
	- fix signedness bug in DMAPI ioctl structure definition

xfsprogs-1.3.4 (04 August 2001)
	- fix endian bug in xfs_db "frag" command
	- small configure script changes to allow cross compilation
	- several man pages updated to document external log usage
	- install another shared library symlink for ld to find
	- switched on -fno-strict-aliasing for library object builds
	- fix several minor compiler warnings when building on IA64

xfsprogs-1.3.3 (27 July 2001)
	- fixes for (hopefully) the last few nits in libtool usage

xfsprogs-1.3.2 (23 July 2001)
	- install static libs and libtool archives into /usr/lib
	- shared libraries are unchanged, however

xfsprogs-1.3.1 (15 July 2001)
	- updated xfs_types.h file from the kernel changes needed for
	  an xfsdump fix.
	- tidy up various aspects of the libtool rework
	- XVM stripe unit/width extraction
	- fix an endian bug in xfs_db "write" command
	- fix a build problem with liblvm.a installed
	- fix bug in xfs_growfs mount option parsing with external log
	- BLKSZSET ioctl now conditional via the Makefile (off by default)
	- rework some of the Debian packaging rules
	- fix sign of BLKGETSIZE ioctl argument in libxfs
	- updated xfs_fs.h with DMAPI setdm details for dump/restore

xfsprogs-1.3.0 (11 July 2001)
	- reworked Makefiles to use libtool
	- new libdisk to allow sharing of generic mount/disk code and
	- also abstracts individual driver support (LVM, MD, XVM..)
	- partition table detection so mkfs.xfs doesn't blindly overwrite
	- small xfs_repair bug fix from Steve

xfsprogs-1.2.8 (02 July 2001)
	- fixed a bug in libxfs /etc/mtab read-only mount detection
	- first try procfs, fall back to /etc/mtab, for read-only mounts
	- sync with recent mount code changes for reiserfs and ext3 probes
	- fix logprint build problem under gcc 3.0

xfsprogs-1.2.7 (22 May 2001)
	- new xfs_freeze(8) command - volume manager snapshot helper

xfsprogs-1.2.6 (15 May 2001)
	- merge support for -d agsize=/su=/sw= (AG, stripe unit/width size)
	- merge support for dynamic configuration of default log size
	- document these and fix a couple of man page typos too

xfsprogs-1.2.5 (07 May 2001)
	- fix missing Makefile include entries for LVM headers
	- configure script default man path now /usr/share/man
	- add experimental xfs_rtcp (realtime copy) command
	- powerpc build failure fixups - thanks to Robert Ramiega
	- cleanup arch-specific code, esp. the byteswab routines
	- as a result, move to -O1 as default for extern inlines

xfsprogs-1.2.4 (01 May 2001)
	- added -L option to mkfs.xfs (filesystem label)

xfsprogs-1.2.3 (27 April 2001)
	- add dquot and quotaoff log item support into xfs_logprint
	- fix logprint core dump reporting AGI in "continue"'d transactions

xfsprogs-1.2.2 (09 April 2001)
	- fix problem in xfs_db (check) group quota logic
	- fixes to warnings from recent gcc and/or 64-bit builds

xfsprogs-1.2.1 (04 April 2001)
	- sync up with recent changes to XFS kernel headers

xfsprogs-1.2.0 (01 April 2001)
	- support for group quota added
	- some headers updated, in particular <xqm.h>
	- now in late stages of beta

xfsprogs-1.1.9 (26 March 2001)
	- added automagic stripe unit/stripe width extraction for MD devices

xfsprogs-1.1.8 (23 March 2001)
	- mkfs heuristics to make a qualified guess of internal logsize

xfsprogs-1.1.7 (20 March 2001)
	- upgraded LVM to 0.9beta6
	- minor rpm spec file changes

xfsprogs-1.1.6 (20 March 2001)
	- fix sparc build failure - fcntl.h missing O_DIRECT
	- added README.quota describing use of quota with XFS

xfsprogs-1.1.5 (12 March 2001)
	- upgraded LVM support to 0.9beta2 (IOP 10)

xfsprogs-1.1.4 (10 March 2001)
	- kernel now supports O_DIRECT - re-enable its use in xfs_mkfile
	- BLKSETSIZE ioctl replaced by BLKBSZSET ioctl in libxfs
	- libxfs_init extended so only mkfs and xfs_repair use BLKBSZSET
	- NOTE: this version requires an XFS kernel from March 9 or later

xfsprogs-1.1.3 (02 March 2001)
	- minor Makefile-related cleanups

xfsprogs-1.1.2 (10 February 2001)
	- added libhandle routines to simplify dump/restore EA support

xfsprogs-1.1.1 (30 January 2001)
	- minor rpm and deb packaging work

xfsprogs-1.1.0 (15 January 2001)
	- rework xfs-cmds package into base, devel and dump packages
	- completed Debian packaging
	- late beta code

xfs-cmds-1.0.7 (02 January 2001)
	- added mkfs support for extracting LVM stripe unit/width
	- libattr (*experimental* extended attributes interface) added
	- removed xfs_fstab.5 man page (merged into mount.8)
	- install xfs_repair into /sbin, not /usr/sbin

xfs-cmds-1.0.6 (04 October 2000)
	- reworked external log format to be IRIX compatible
	- mkfs, repair, db, logprint now work with new format
	- xfs_admin added for setting filesystem label

xfs-cmds-1.0.5 (18 September 2000)
	- minor bug fixes
	- first beta release

xfs-cmds-1.0.4 (18 August 2000)
	- minor bug fixes
	- xfs_growfs added
	- xfs_info added
	- late alpha code

xfs-cmds-1.0.3 (16 August 2000)
	- numerous bug fixes
	- xfsdump and xfsrestore added
	- xfsstats added
	- fsck.xfs (symlink to /bin/true) added
	- demise of sim library complete, mkfs and repair reworked
	- no longer need to have an XFS kernel handy for building xfs-cmds
	- xfs_copy compiles on Linux
	- dump/restore README added
	- late alpha code

xfs-cmds-1.0.2 (27 July 2000)
	- numerous bug fixes
	- xfs_attr (extended attributes) command added
	- fsr_xfs added (ported by jones@tacc.utexas.edu)
	- LVM+XFS README added
	- early alpha code

xfs-cmds-1.0.1 (5 July 2000)
	- numerous bug fixes
	- reworked build environment
	- begun work on user/kernel separation
	- early alpha code

xfs-cmds-1.0.0 (16 June 2000)
	- initial release for USENIX CDs
	- early alpha code
